{$APPTYPE CONSOLE}
program TestPax;

uses
  PaxCompiler, PaxProgram, IMPORT_Common;

type
  THandler = class
    procedure DoImportGlobalMembers(Sender: TPaxCompiler);
  end;

procedure THandler.DoImportGlobalMembers(Sender: TPaxCompiler);
begin
  Register_Common(Sender);
end;

var
  PaxCompiler1: TPaxCompiler;
  PaxProgram1: TPaxProgram;
  PaxPascalLanguage1: TPaxPascalLanguage;
  Handler: THandler;
  I: Integer;
begin
  Handler := THandler.Create;
  PaxCompiler1 := TPaxCompiler.Create(nil);
  PaxProgram1 := TPaxProgram.Create(nil);
  PaxPascalLanguage1 := TPaxPascalLanguage.Create(nil);

  PaxCompiler1.OnImportGlobalMembers := Handler.DoImportGlobalMembers;
  try
    PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
    PaxCompiler1.AddModule('1', 'Pascal');
    PaxCompiler1.AddCodeFromFile('1', 'script.txt');
    if PaxCompiler1.Compile(PaxProgram1) then
    begin
      PaxProgram1.Run;
    end
    else
    begin
      writeln(PaxCompiler1.ErrorMessage[0]);
      writeln(PaxCompiler1.ErrorLineNumber[0]);
      writeln(PaxCompiler1.ErrorLine[0]);
    end;

    for I:=0 to PaxCompiler1.WarningCount - 1 do
    begin
      writeln(PaxCompiler1.WarningMessage[I]);
      writeln(PaxCompiler1.WarningLineNumber[I]);
      writeln(PaxCompiler1.WarningLine[I]);
    end;

  finally
    PaxCompiler1.Free;
    PaxProgram1.Free;
    PaxPascalLanguage1.Free;
    Handler.Free;
  end;
  writeln('Press any key...');
  Readln;
end.
