//****************************************************************************
// Unit Name: System.Math
//****************************************************************************
// This file is auto generated with paxCompiler engine.                       
// Import mode: local import, global members only.
// ---------------------------------------------------------------------------
// Site: http://www.paxcompiler.com                                           
// Author: Alexander Baranovsky (paxscript@gmail.com)                         
// ---------------------------------------------------------------------------
// Copyright (c) Alexander Baranovsky, 2014.                                  
// ---------------------------------------------------------------------------
// Portion copyright Full Circle Development Ltd.                             
// Content: initial design of importer.                                       
// ---------------------------------------------------------------------------
// Code Version: 1.0                                                    
//****************************************************************************

unit IMP_System.Math;
interface
uses
  PaxCompiler;


function Register_System_Math(compiler: TPaxCompiler): Integer;


implementation


uses
  PAXCOMP_STDLIB,
  PaxRegister,
  System.SysUtils,
  System.Types,
  Classes,
  System.Math;


function RegisterConstant__MinSingle(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MinSingle') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'MinSingle', 1.4012984643248170709e-45);
end;


function RegisterConstant__MaxSingle(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MaxSingle') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'MaxSingle', 340282346638528859811704183484516925440.0);
end;


function RegisterConstant__MinDouble(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MinDouble') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'MinDouble', 4.9406564584124654418e-324);
end;


function RegisterConstant__MaxDouble(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MaxDouble') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'MaxDouble', 1.7976931348623157081e+308);
end;


function RegisterConstant__MinExtended(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MinExtended') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'MinExtended', MinDouble);
end;


function RegisterConstant__MaxExtended(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MaxExtended') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'MaxExtended', MaxDouble);
end;


function RegisterConstant__MinComp(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MinComp') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'MinComp     = -9223372036854775807;');
end;


function RegisterConstant__MaxComp(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MaxComp') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'MaxComp     =  9223372036854775807;');
end;


function Address_ArcCos_1: Pointer;
type
  T = function (const X : Extended) : Extended;
var
  P: T;
begin
  P := ArcCos;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCos(const X : Extended) : Extended; overload;
function RegisterFunction_ArcCos_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCos'
    , _typeEXTENDED // result type
    , Address_ArcCos_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcCos_2: Pointer;
type
  T = function (const X : Double) : Double;
var
  P: T;
begin
  P := ArcCos;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCos(const X : Double) : Double; overload;
function RegisterFunction_ArcCos_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCos'
    , _typeDOUBLE // result type
    , Address_ArcCos_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcCos_3: Pointer;
type
  T = function (const X : Single) : Single;
var
  P: T;
begin
  P := ArcCos;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCos(const X : Single) : Single; overload;
function RegisterFunction_ArcCos_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCos'
    , _typeSINGLE // result type
    , Address_ArcCos_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcSin_1: Pointer;
type
  T = function (const X : Extended) : Extended;
var
  P: T;
begin
  P := ArcSin;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSin(const X : Extended) : Extended; overload;
function RegisterFunction_ArcSin_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSin') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSin'
    , _typeEXTENDED // result type
    , Address_ArcSin_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcSin_2: Pointer;
type
  T = function (const X : Double) : Double;
var
  P: T;
begin
  P := ArcSin;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSin(const X : Double) : Double; overload;
function RegisterFunction_ArcSin_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSin') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSin'
    , _typeDOUBLE // result type
    , Address_ArcSin_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcSin_3: Pointer;
type
  T = function (const X : Single) : Single;
var
  P: T;
begin
  P := ArcSin;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSin(const X : Single) : Single; overload;
function RegisterFunction_ArcSin_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSin') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSin'
    , _typeSINGLE // result type
    , Address_ArcSin_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcTan2_1: Pointer;
type
  T = function (const Y, X: Extended): Extended;
var
  P: T;
begin
  P := ArcTan2;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcTan2(const Y, X: Extended): Extended; overload;
function RegisterFunction_ArcTan2_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcTan2') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcTan2'
    , _typeEXTENDED // result type
    , Address_ArcTan2_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Y', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcTan2_2: Pointer;
type
  T = function (const Y, X: Double): Double;
var
  P: T;
begin
  P := ArcTan2;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcTan2(const Y, X: Double): Double; overload;
function RegisterFunction_ArcTan2_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcTan2') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcTan2'
    , _typeDOUBLE // result type
    , Address_ArcTan2_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Y', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcTan2_3: Pointer;
type
  T = function (const Y, X: Single): Single;
var
  P: T;
begin
  P := ArcTan2;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcTan2(const Y, X: Single): Single; overload;
function RegisterFunction_ArcTan2_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcTan2') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcTan2'
    , _typeSINGLE // result type
    , Address_ArcTan2_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Y', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_SinCos_1: Pointer;
type
  T = procedure (const Theta: Single; var Sin, Cos: Single);
var
  P: T;
begin
  P := SinCos;
  Move(P, result, SizeOf(Pointer));
end;


// procedure SinCos(const Theta: Single; var Sin, Cos: Single); overload;
function RegisterProcedure_SinCos_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SinCos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SinCos'
    , _typeVOID // result type
    , Address_SinCos_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Theta', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'Sin', _typeSINGLE, _parVAR);
  compiler.RegisterParameter(result, 'Cos', _typeSINGLE, _parVAR);
end;


function Address_SinCos_2: Pointer;
type
  T = procedure (const Theta: Double; var Sin, Cos: Double);
var
  P: T;
begin
  P := SinCos;
  Move(P, result, SizeOf(Pointer));
end;


// procedure SinCos(const Theta: Double; var Sin, Cos: Double); overload;
function RegisterProcedure_SinCos_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SinCos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SinCos'
    , _typeVOID // result type
    , Address_SinCos_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Theta', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'Sin', _typeDOUBLE, _parVAR);
  compiler.RegisterParameter(result, 'Cos', _typeDOUBLE, _parVAR);
end;


function Address_SinCos_3: Pointer;
type
  T = procedure (const Theta: Extended; var Sin, Cos: Extended);
var
  P: T;
begin
  P := SinCos;
  Move(P, result, SizeOf(Pointer));
end;


// procedure SinCos(const Theta: Extended; var Sin, Cos: Extended); overload;
function RegisterProcedure_SinCos_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SinCos') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SinCos'
    , _typeVOID // result type
    , Address_SinCos_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Theta', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Sin', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'Cos', _typeEXTENDED, _parVAR);
end;


function Address_Tan_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Tan;
  Move(P, result, SizeOf(Pointer));
end;


// function Tan(const X: Single): Single; overload;
function RegisterFunction_Tan_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Tan') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Tan'
    , _typeSINGLE // result type
    , Address_Tan_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Tan_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Tan;
  Move(P, result, SizeOf(Pointer));
end;


// function Tan(const X: Double): Double; overload;
function RegisterFunction_Tan_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Tan') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Tan'
    , _typeDOUBLE // result type
    , Address_Tan_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Tan_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Tan;
  Move(P, result, SizeOf(Pointer));
end;


// function Tan(const X: Extended): Extended; overload;
function RegisterFunction_Tan_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Tan') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Tan'
    , _typeEXTENDED // result type
    , Address_Tan_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Cotan_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Cotan;
  Move(P, result, SizeOf(Pointer));
end;


// function Cotan(const X: Single): Single; overload;
function RegisterFunction_Cotan_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cotan') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cotan'
    , _typeSINGLE // result type
    , Address_Cotan_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Cotan_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Cotan;
  Move(P, result, SizeOf(Pointer));
end;


// function Cotan(const X: Double): Double; overload;
function RegisterFunction_Cotan_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cotan') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cotan'
    , _typeDOUBLE // result type
    , Address_Cotan_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Cotan_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Cotan;
  Move(P, result, SizeOf(Pointer));
end;


// function Cotan(const X: Extended): Extended; overload;
function RegisterFunction_Cotan_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cotan') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cotan'
    , _typeEXTENDED // result type
    , Address_Cotan_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Secant_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Secant;
  Move(P, result, SizeOf(Pointer));
end;


// function Secant(const X: Single): Single; overload;
function RegisterFunction_Secant_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Secant') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Secant'
    , _typeSINGLE // result type
    , Address_Secant_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Secant_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Secant;
  Move(P, result, SizeOf(Pointer));
end;


// function Secant(const X: Double): Double; overload;
function RegisterFunction_Secant_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Secant') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Secant'
    , _typeDOUBLE // result type
    , Address_Secant_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Secant_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Secant;
  Move(P, result, SizeOf(Pointer));
end;


// function Secant(const X: Extended): Extended; overload;
function RegisterFunction_Secant_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Secant') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Secant'
    , _typeEXTENDED // result type
    , Address_Secant_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Cosecant_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Cosecant;
  Move(P, result, SizeOf(Pointer));
end;


// function Cosecant(const X: Single): Single; overload;
function RegisterFunction_Cosecant_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cosecant') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cosecant'
    , _typeSINGLE // result type
    , Address_Cosecant_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Cosecant_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Cosecant;
  Move(P, result, SizeOf(Pointer));
end;


// function Cosecant(const X: Double): Double; overload;
function RegisterFunction_Cosecant_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cosecant') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cosecant'
    , _typeDOUBLE // result type
    , Address_Cosecant_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Cosecant_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Cosecant;
  Move(P, result, SizeOf(Pointer));
end;


// function Cosecant(const X: Extended): Extended; overload;
function RegisterFunction_Cosecant_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cosecant') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cosecant'
    , _typeEXTENDED // result type
    , Address_Cosecant_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Hypot_1: Pointer;
type
  T = function (const X, Y: Single): Single;
var
  P: T;
begin
  P := Hypot;
  Move(P, result, SizeOf(Pointer));
end;


// function Hypot(const X, Y: Single): Single; overload;
function RegisterFunction_Hypot_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Hypot') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Hypot'
    , _typeSINGLE // result type
    , Address_Hypot_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'Y', _typeSINGLE, _parCONST);
end;


function Address_Hypot_2: Pointer;
type
  T = function (const X, Y: Double): Double;
var
  P: T;
begin
  P := Hypot;
  Move(P, result, SizeOf(Pointer));
end;


// function Hypot(const X, Y: Double): Double; overload;
function RegisterFunction_Hypot_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Hypot') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Hypot'
    , _typeDOUBLE // result type
    , Address_Hypot_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'Y', _typeDOUBLE, _parCONST);
end;


function Address_Hypot_3: Pointer;
type
  T = function (const X, Y: Extended): Extended;
var
  P: T;
begin
  P := Hypot;
  Move(P, result, SizeOf(Pointer));
end;


// function Hypot(const X, Y: Extended): Extended; overload;
function RegisterFunction_Hypot_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Hypot') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Hypot'
    , _typeEXTENDED // result type
    , Address_Hypot_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Y', _typeEXTENDED, _parCONST);
end;


function Address_RadToDeg_1: Pointer;
type
  T = function (const Radians: Single): Single;
var
  P: T;
begin
  P := RadToDeg;
  Move(P, result, SizeOf(Pointer));
end;


// function RadToDeg(const Radians: Single): Single; inline; overload;
function RegisterFunction_RadToDeg_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RadToDeg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RadToDeg'
    , _typeSINGLE // result type
    , Address_RadToDeg_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Radians', _typeSINGLE, _parCONST);
end;


function Address_RadToDeg_2: Pointer;
type
  T = function (const Radians: Double): Double;
var
  P: T;
begin
  P := RadToDeg;
  Move(P, result, SizeOf(Pointer));
end;


// function RadToDeg(const Radians: Double): Double; inline; overload;
function RegisterFunction_RadToDeg_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RadToDeg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RadToDeg'
    , _typeDOUBLE // result type
    , Address_RadToDeg_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Radians', _typeDOUBLE, _parCONST);
end;


function Address_RadToDeg_3: Pointer;
type
  T = function (const Radians: Extended): Extended;
var
  P: T;
begin
  P := RadToDeg;
  Move(P, result, SizeOf(Pointer));
end;


// function RadToDeg(const Radians: Extended): Extended; inline; overload;
function RegisterFunction_RadToDeg_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RadToDeg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RadToDeg'
    , _typeEXTENDED // result type
    , Address_RadToDeg_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Radians', _typeEXTENDED, _parCONST);
end;


function Address_RadToGrad_1: Pointer;
type
  T = function (const Radians: Single): Single;
var
  P: T;
begin
  P := RadToGrad;
  Move(P, result, SizeOf(Pointer));
end;


// function RadToGrad(const Radians: Single): Single; inline; overload;
function RegisterFunction_RadToGrad_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RadToGrad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RadToGrad'
    , _typeSINGLE // result type
    , Address_RadToGrad_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Radians', _typeSINGLE, _parCONST);
end;


function Address_RadToGrad_2: Pointer;
type
  T = function (const Radians: Double): Double;
var
  P: T;
begin
  P := RadToGrad;
  Move(P, result, SizeOf(Pointer));
end;


// function RadToGrad(const Radians: Double): Double; inline; overload;
function RegisterFunction_RadToGrad_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RadToGrad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RadToGrad'
    , _typeDOUBLE // result type
    , Address_RadToGrad_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Radians', _typeDOUBLE, _parCONST);
end;


function Address_RadToGrad_3: Pointer;
type
  T = function (const Radians: Extended): Extended;
var
  P: T;
begin
  P := RadToGrad;
  Move(P, result, SizeOf(Pointer));
end;


// function RadToGrad(const Radians: Extended): Extended; inline; overload;
function RegisterFunction_RadToGrad_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RadToGrad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RadToGrad'
    , _typeEXTENDED // result type
    , Address_RadToGrad_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Radians', _typeEXTENDED, _parCONST);
end;


function Address_RadToCycle_1: Pointer;
type
  T = function (const Radians: Single): Single;
var
  P: T;
begin
  P := RadToCycle;
  Move(P, result, SizeOf(Pointer));
end;


// function RadToCycle(const Radians: Single): Single; inline; overload;
function RegisterFunction_RadToCycle_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RadToCycle') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RadToCycle'
    , _typeSINGLE // result type
    , Address_RadToCycle_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Radians', _typeSINGLE, _parCONST);
end;


function Address_RadToCycle_2: Pointer;
type
  T = function (const Radians: Double): Double;
var
  P: T;
begin
  P := RadToCycle;
  Move(P, result, SizeOf(Pointer));
end;


// function RadToCycle(const Radians: Double): Double; inline; overload;
function RegisterFunction_RadToCycle_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RadToCycle') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RadToCycle'
    , _typeDOUBLE // result type
    , Address_RadToCycle_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Radians', _typeDOUBLE, _parCONST);
end;


function Address_RadToCycle_3: Pointer;
type
  T = function (const Radians: Extended): Extended;
var
  P: T;
begin
  P := RadToCycle;
  Move(P, result, SizeOf(Pointer));
end;


// function RadToCycle(const Radians: Extended): Extended; inline; overload;
function RegisterFunction_RadToCycle_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RadToCycle') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RadToCycle'
    , _typeEXTENDED // result type
    , Address_RadToCycle_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Radians', _typeEXTENDED, _parCONST);
end;


function Address_DegToRad_1: Pointer;
type
  T = function (const Degrees: Single): Single;
var
  P: T;
begin
  P := DegToRad;
  Move(P, result, SizeOf(Pointer));
end;


// function DegToRad(const Degrees: Single): Single; inline; overload;
function RegisterFunction_DegToRad_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegToRad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegToRad'
    , _typeSINGLE // result type
    , Address_DegToRad_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeSINGLE, _parCONST);
end;


function Address_DegToRad_2: Pointer;
type
  T = function (const Degrees: Double): Double;
var
  P: T;
begin
  P := DegToRad;
  Move(P, result, SizeOf(Pointer));
end;


// function DegToRad(const Degrees: Double): Double; inline; overload;
function RegisterFunction_DegToRad_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegToRad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegToRad'
    , _typeDOUBLE // result type
    , Address_DegToRad_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeDOUBLE, _parCONST);
end;


function Address_DegToRad_3: Pointer;
type
  T = function (const Degrees: Extended): Extended;
var
  P: T;
begin
  P := DegToRad;
  Move(P, result, SizeOf(Pointer));
end;


// function DegToRad(const Degrees: Extended): Extended; inline; overload;
function RegisterFunction_DegToRad_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegToRad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegToRad'
    , _typeEXTENDED // result type
    , Address_DegToRad_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeEXTENDED, _parCONST);
end;


function Address_DegToGrad_1: Pointer;
type
  T = function (const Degrees: Single): Single;
var
  P: T;
begin
  P := DegToGrad;
  Move(P, result, SizeOf(Pointer));
end;


// function DegToGrad(const Degrees: Single): Single; overload;
function RegisterFunction_DegToGrad_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegToGrad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegToGrad'
    , _typeSINGLE // result type
    , Address_DegToGrad_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeSINGLE, _parCONST);
end;


function Address_DegToGrad_2: Pointer;
type
  T = function (const Degrees: Double): Double;
var
  P: T;
begin
  P := DegToGrad;
  Move(P, result, SizeOf(Pointer));
end;


// function DegToGrad(const Degrees: Double): Double; overload;
function RegisterFunction_DegToGrad_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegToGrad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegToGrad'
    , _typeDOUBLE // result type
    , Address_DegToGrad_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeDOUBLE, _parCONST);
end;


function Address_DegToGrad_3: Pointer;
type
  T = function (const Degrees: Extended): Extended;
var
  P: T;
begin
  P := DegToGrad;
  Move(P, result, SizeOf(Pointer));
end;


// function DegToGrad(const Degrees: Extended): Extended; overload;
function RegisterFunction_DegToGrad_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegToGrad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegToGrad'
    , _typeEXTENDED // result type
    , Address_DegToGrad_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeEXTENDED, _parCONST);
end;


function Address_DegToCycle_1: Pointer;
type
  T = function (const Degrees: Single): Single;
var
  P: T;
begin
  P := DegToCycle;
  Move(P, result, SizeOf(Pointer));
end;


// function DegToCycle(const Degrees: Single): Single; overload;
function RegisterFunction_DegToCycle_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegToCycle') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegToCycle'
    , _typeSINGLE // result type
    , Address_DegToCycle_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeSINGLE, _parCONST);
end;


function Address_DegToCycle_2: Pointer;
type
  T = function (const Degrees: Double): Double;
var
  P: T;
begin
  P := DegToCycle;
  Move(P, result, SizeOf(Pointer));
end;


// function DegToCycle(const Degrees: Double): Double; overload;
function RegisterFunction_DegToCycle_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegToCycle') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegToCycle'
    , _typeDOUBLE // result type
    , Address_DegToCycle_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeDOUBLE, _parCONST);
end;


function Address_DegToCycle_3: Pointer;
type
  T = function (const Degrees: Extended): Extended;
var
  P: T;
begin
  P := DegToCycle;
  Move(P, result, SizeOf(Pointer));
end;


// function DegToCycle(const Degrees: Extended): Extended; overload;
function RegisterFunction_DegToCycle_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegToCycle') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegToCycle'
    , _typeEXTENDED // result type
    , Address_DegToCycle_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeEXTENDED, _parCONST);
end;


function Address_DegNormalize_1: Pointer;
type
  T = function (const Degrees: Single): Single;
var
  P: T;
begin
  P := DegNormalize;
  Move(P, result, SizeOf(Pointer));
end;


// function DegNormalize(const Degrees: Single): Single; inline; overload;
function RegisterFunction_DegNormalize_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegNormalize') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegNormalize'
    , _typeSINGLE // result type
    , Address_DegNormalize_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeSINGLE, _parCONST);
end;


function Address_DegNormalize_2: Pointer;
type
  T = function (const Degrees: Double): Double;
var
  P: T;
begin
  P := DegNormalize;
  Move(P, result, SizeOf(Pointer));
end;


// function DegNormalize(const Degrees: Double): Double; inline; overload;
function RegisterFunction_DegNormalize_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegNormalize') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegNormalize'
    , _typeDOUBLE // result type
    , Address_DegNormalize_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeDOUBLE, _parCONST);
end;


function Address_DegNormalize_3: Pointer;
type
  T = function (const Degrees: Extended): Extended;
var
  P: T;
begin
  P := DegNormalize;
  Move(P, result, SizeOf(Pointer));
end;


// function DegNormalize(const Degrees: Extended): Extended; inline; overload;
function RegisterFunction_DegNormalize_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DegNormalize') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DegNormalize'
    , _typeEXTENDED // result type
    , Address_DegNormalize_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Degrees', _typeEXTENDED, _parCONST);
end;


function Address_GradToRad_1: Pointer;
type
  T = function (const Grads: Single): Single;
var
  P: T;
begin
  P := GradToRad;
  Move(P, result, SizeOf(Pointer));
end;


// function GradToRad(const Grads: Single): Single; inline; overload;
function RegisterFunction_GradToRad_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GradToRad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GradToRad'
    , _typeSINGLE // result type
    , Address_GradToRad_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Grads', _typeSINGLE, _parCONST);
end;


function Address_GradToRad_2: Pointer;
type
  T = function (const Grads: Double): Double;
var
  P: T;
begin
  P := GradToRad;
  Move(P, result, SizeOf(Pointer));
end;


// function GradToRad(const Grads: Double): Double; inline; overload;
function RegisterFunction_GradToRad_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GradToRad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GradToRad'
    , _typeDOUBLE // result type
    , Address_GradToRad_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Grads', _typeDOUBLE, _parCONST);
end;


function Address_GradToRad_3: Pointer;
type
  T = function (const Grads: Extended): Extended;
var
  P: T;
begin
  P := GradToRad;
  Move(P, result, SizeOf(Pointer));
end;


// function GradToRad(const Grads: Extended): Extended; inline; overload;
function RegisterFunction_GradToRad_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GradToRad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GradToRad'
    , _typeEXTENDED // result type
    , Address_GradToRad_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Grads', _typeEXTENDED, _parCONST);
end;


function Address_GradToDeg_1: Pointer;
type
  T = function (const Grads: Single): Single;
var
  P: T;
begin
  P := GradToDeg;
  Move(P, result, SizeOf(Pointer));
end;


// function GradToDeg(const Grads: Single): Single; overload;
function RegisterFunction_GradToDeg_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GradToDeg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GradToDeg'
    , _typeSINGLE // result type
    , Address_GradToDeg_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Grads', _typeSINGLE, _parCONST);
end;


function Address_GradToDeg_2: Pointer;
type
  T = function (const Grads: Double): Double;
var
  P: T;
begin
  P := GradToDeg;
  Move(P, result, SizeOf(Pointer));
end;


// function GradToDeg(const Grads: Double): Double; overload;
function RegisterFunction_GradToDeg_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GradToDeg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GradToDeg'
    , _typeDOUBLE // result type
    , Address_GradToDeg_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Grads', _typeDOUBLE, _parCONST);
end;


function Address_GradToDeg_3: Pointer;
type
  T = function (const Grads: Extended): Extended;
var
  P: T;
begin
  P := GradToDeg;
  Move(P, result, SizeOf(Pointer));
end;


// function GradToDeg(const Grads: Extended): Extended; overload;
function RegisterFunction_GradToDeg_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GradToDeg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GradToDeg'
    , _typeEXTENDED // result type
    , Address_GradToDeg_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Grads', _typeEXTENDED, _parCONST);
end;


function Address_GradToCycle_1: Pointer;
type
  T = function (const Grads: Single): Single;
var
  P: T;
begin
  P := GradToCycle;
  Move(P, result, SizeOf(Pointer));
end;


// function GradToCycle(const Grads: Single): Single; overload;
function RegisterFunction_GradToCycle_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GradToCycle') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GradToCycle'
    , _typeSINGLE // result type
    , Address_GradToCycle_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Grads', _typeSINGLE, _parCONST);
end;


function Address_GradToCycle_2: Pointer;
type
  T = function (const Grads: Double): Double;
var
  P: T;
begin
  P := GradToCycle;
  Move(P, result, SizeOf(Pointer));
end;


// function GradToCycle(const Grads: Double): Double; overload;
function RegisterFunction_GradToCycle_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GradToCycle') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GradToCycle'
    , _typeDOUBLE // result type
    , Address_GradToCycle_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Grads', _typeDOUBLE, _parCONST);
end;


function Address_GradToCycle_3: Pointer;
type
  T = function (const Grads: Extended): Extended;
var
  P: T;
begin
  P := GradToCycle;
  Move(P, result, SizeOf(Pointer));
end;


// function GradToCycle(const Grads: Extended): Extended; overload;
function RegisterFunction_GradToCycle_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GradToCycle') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GradToCycle'
    , _typeEXTENDED // result type
    , Address_GradToCycle_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Grads', _typeEXTENDED, _parCONST);
end;


function Address_CycleToRad_1: Pointer;
type
  T = function (const Cycles: Single): Single;
var
  P: T;
begin
  P := CycleToRad;
  Move(P, result, SizeOf(Pointer));
end;


// function CycleToRad(const Cycles: Single): Single; inline; overload;
function RegisterFunction_CycleToRad_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CycleToRad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CycleToRad'
    , _typeSINGLE // result type
    , Address_CycleToRad_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Cycles', _typeSINGLE, _parCONST);
end;


function Address_CycleToRad_2: Pointer;
type
  T = function (const Cycles: Double): Double;
var
  P: T;
begin
  P := CycleToRad;
  Move(P, result, SizeOf(Pointer));
end;


// function CycleToRad(const Cycles: Double): Double; inline; overload;
function RegisterFunction_CycleToRad_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CycleToRad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CycleToRad'
    , _typeDOUBLE // result type
    , Address_CycleToRad_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Cycles', _typeDOUBLE, _parCONST);
end;


function Address_CycleToRad_3: Pointer;
type
  T = function (const Cycles: Extended): Extended;
var
  P: T;
begin
  P := CycleToRad;
  Move(P, result, SizeOf(Pointer));
end;


// function CycleToRad(const Cycles: Extended): Extended; inline; overload;
function RegisterFunction_CycleToRad_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CycleToRad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CycleToRad'
    , _typeEXTENDED // result type
    , Address_CycleToRad_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Cycles', _typeEXTENDED, _parCONST);
end;


function Address_CycleToDeg_1: Pointer;
type
  T = function (const Cycles: Single): Single;
var
  P: T;
begin
  P := CycleToDeg;
  Move(P, result, SizeOf(Pointer));
end;


// function CycleToDeg(const Cycles: Single): Single; overload;
function RegisterFunction_CycleToDeg_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CycleToDeg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CycleToDeg'
    , _typeSINGLE // result type
    , Address_CycleToDeg_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Cycles', _typeSINGLE, _parCONST);
end;


function Address_CycleToDeg_2: Pointer;
type
  T = function (const Cycles: Double): Double;
var
  P: T;
begin
  P := CycleToDeg;
  Move(P, result, SizeOf(Pointer));
end;


// function CycleToDeg(const Cycles: Double): Double; overload;
function RegisterFunction_CycleToDeg_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CycleToDeg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CycleToDeg'
    , _typeDOUBLE // result type
    , Address_CycleToDeg_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Cycles', _typeDOUBLE, _parCONST);
end;


function Address_CycleToDeg_3: Pointer;
type
  T = function (const Cycles: Extended): Extended;
var
  P: T;
begin
  P := CycleToDeg;
  Move(P, result, SizeOf(Pointer));
end;


// function CycleToDeg(const Cycles: Extended): Extended; overload;
function RegisterFunction_CycleToDeg_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CycleToDeg') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CycleToDeg'
    , _typeEXTENDED // result type
    , Address_CycleToDeg_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Cycles', _typeEXTENDED, _parCONST);
end;


function Address_CycleToGrad_1: Pointer;
type
  T = function (const Cycles: Single): Single;
var
  P: T;
begin
  P := CycleToGrad;
  Move(P, result, SizeOf(Pointer));
end;


// function CycleToGrad(const Cycles: Single): Single; overload;
function RegisterFunction_CycleToGrad_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CycleToGrad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CycleToGrad'
    , _typeSINGLE // result type
    , Address_CycleToGrad_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Cycles', _typeSINGLE, _parCONST);
end;


function Address_CycleToGrad_2: Pointer;
type
  T = function (const Cycles: Double): Double;
var
  P: T;
begin
  P := CycleToGrad;
  Move(P, result, SizeOf(Pointer));
end;


// function CycleToGrad(const Cycles: Double): Double; overload;
function RegisterFunction_CycleToGrad_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CycleToGrad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CycleToGrad'
    , _typeDOUBLE // result type
    , Address_CycleToGrad_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Cycles', _typeDOUBLE, _parCONST);
end;


function Address_CycleToGrad_3: Pointer;
type
  T = function (const Cycles: Extended): Extended;
var
  P: T;
begin
  P := CycleToGrad;
  Move(P, result, SizeOf(Pointer));
end;


// function CycleToGrad(const Cycles: Extended): Extended; overload;
function RegisterFunction_CycleToGrad_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CycleToGrad') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CycleToGrad'
    , _typeEXTENDED // result type
    , Address_CycleToGrad_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Cycles', _typeEXTENDED, _parCONST);
end;


function Address_Cot_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Cot;
  Move(P, result, SizeOf(Pointer));
end;


// function Cot(const X: Single): Single; inline; overload;
function RegisterFunction_Cot_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cot') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cot'
    , _typeSINGLE // result type
    , Address_Cot_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Cot_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Cot;
  Move(P, result, SizeOf(Pointer));
end;


// function Cot(const X: Double): Double; inline; overload;
function RegisterFunction_Cot_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cot') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cot'
    , _typeDOUBLE // result type
    , Address_Cot_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Cot_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Cot;
  Move(P, result, SizeOf(Pointer));
end;


// function Cot(const X: Extended): Extended; inline; overload;
function RegisterFunction_Cot_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cot') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cot'
    , _typeEXTENDED // result type
    , Address_Cot_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Sec_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Sec;
  Move(P, result, SizeOf(Pointer));
end;


// function Sec(const X: Single): Single; inline; overload;
function RegisterFunction_Sec_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sec') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sec'
    , _typeSINGLE // result type
    , Address_Sec_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Sec_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Sec;
  Move(P, result, SizeOf(Pointer));
end;


// function Sec(const X: Double): Double; inline; overload;
function RegisterFunction_Sec_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sec') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sec'
    , _typeDOUBLE // result type
    , Address_Sec_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Sec_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Sec;
  Move(P, result, SizeOf(Pointer));
end;


// function Sec(const X: Extended): Extended; inline; overload;
function RegisterFunction_Sec_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sec') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sec'
    , _typeEXTENDED // result type
    , Address_Sec_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Csc_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Csc;
  Move(P, result, SizeOf(Pointer));
end;


// function Csc(const X: Single): Single; inline; overload;
function RegisterFunction_Csc_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Csc') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Csc'
    , _typeSINGLE // result type
    , Address_Csc_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Csc_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Csc;
  Move(P, result, SizeOf(Pointer));
end;


// function Csc(const X: Double): Double; inline; overload;
function RegisterFunction_Csc_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Csc') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Csc'
    , _typeDOUBLE // result type
    , Address_Csc_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Csc_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Csc;
  Move(P, result, SizeOf(Pointer));
end;


// function Csc(const X: Extended): Extended; inline; overload;
function RegisterFunction_Csc_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Csc') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Csc'
    , _typeEXTENDED // result type
    , Address_Csc_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Cosh_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Cosh;
  Move(P, result, SizeOf(Pointer));
end;


// function Cosh(const X: Single): Single; overload;
function RegisterFunction_Cosh_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cosh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cosh'
    , _typeSINGLE // result type
    , Address_Cosh_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Cosh_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Cosh;
  Move(P, result, SizeOf(Pointer));
end;


// function Cosh(const X: Double): Double; overload;
function RegisterFunction_Cosh_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cosh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cosh'
    , _typeDOUBLE // result type
    , Address_Cosh_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Cosh_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Cosh;
  Move(P, result, SizeOf(Pointer));
end;


// function Cosh(const X: Extended): Extended; overload;
function RegisterFunction_Cosh_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Cosh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Cosh'
    , _typeEXTENDED // result type
    , Address_Cosh_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Sinh_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Sinh;
  Move(P, result, SizeOf(Pointer));
end;


// function Sinh(const X: Single): Single; overload;
function RegisterFunction_Sinh_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sinh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sinh'
    , _typeSINGLE // result type
    , Address_Sinh_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Sinh_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Sinh;
  Move(P, result, SizeOf(Pointer));
end;


// function Sinh(const X: Double): Double; overload;
function RegisterFunction_Sinh_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sinh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sinh'
    , _typeDOUBLE // result type
    , Address_Sinh_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Sinh_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Sinh;
  Move(P, result, SizeOf(Pointer));
end;


// function Sinh(const X: Extended): Extended; overload;
function RegisterFunction_Sinh_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sinh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sinh'
    , _typeEXTENDED // result type
    , Address_Sinh_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Tanh_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Tanh;
  Move(P, result, SizeOf(Pointer));
end;


// function Tanh(const X: Single): Single; overload;
function RegisterFunction_Tanh_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Tanh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Tanh'
    , _typeSINGLE // result type
    , Address_Tanh_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Tanh_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Tanh;
  Move(P, result, SizeOf(Pointer));
end;


// function Tanh(const X: Double): Double; overload;
function RegisterFunction_Tanh_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Tanh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Tanh'
    , _typeDOUBLE // result type
    , Address_Tanh_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Tanh_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Tanh;
  Move(P, result, SizeOf(Pointer));
end;


// function Tanh(const X: Extended): Extended; overload;
function RegisterFunction_Tanh_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Tanh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Tanh'
    , _typeEXTENDED // result type
    , Address_Tanh_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_CotH_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := CotH;
  Move(P, result, SizeOf(Pointer));
end;


// function CotH(const X: Single): Single; inline; overload;
function RegisterFunction_CotH_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CotH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CotH'
    , _typeSINGLE // result type
    , Address_CotH_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_CotH_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := CotH;
  Move(P, result, SizeOf(Pointer));
end;


// function CotH(const X: Double): Double; inline; overload;
function RegisterFunction_CotH_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CotH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CotH'
    , _typeDOUBLE // result type
    , Address_CotH_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_CotH_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := CotH;
  Move(P, result, SizeOf(Pointer));
end;


// function CotH(const X: Extended): Extended; inline; overload;
function RegisterFunction_CotH_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CotH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CotH'
    , _typeEXTENDED // result type
    , Address_CotH_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_SecH_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := SecH;
  Move(P, result, SizeOf(Pointer));
end;


// function SecH(const X: Single): Single; inline; overload;
function RegisterFunction_SecH_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SecH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SecH'
    , _typeSINGLE // result type
    , Address_SecH_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_SecH_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := SecH;
  Move(P, result, SizeOf(Pointer));
end;


// function SecH(const X: Double): Double; inline; overload;
function RegisterFunction_SecH_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SecH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SecH'
    , _typeDOUBLE // result type
    , Address_SecH_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_SecH_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := SecH;
  Move(P, result, SizeOf(Pointer));
end;


// function SecH(const X: Extended): Extended; inline; overload;
function RegisterFunction_SecH_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SecH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SecH'
    , _typeEXTENDED // result type
    , Address_SecH_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_CscH_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := CscH;
  Move(P, result, SizeOf(Pointer));
end;


// function CscH(const X: Single): Single; inline; overload;
function RegisterFunction_CscH_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CscH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CscH'
    , _typeSINGLE // result type
    , Address_CscH_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_CscH_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := CscH;
  Move(P, result, SizeOf(Pointer));
end;


// function CscH(const X: Double): Double; inline; overload;
function RegisterFunction_CscH_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CscH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CscH'
    , _typeDOUBLE // result type
    , Address_CscH_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_CscH_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := CscH;
  Move(P, result, SizeOf(Pointer));
end;


// function CscH(const X: Extended): Extended; inline; overload;
function RegisterFunction_CscH_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CscH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CscH'
    , _typeEXTENDED // result type
    , Address_CscH_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcCot_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := ArcCot;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCot(const X: Single): Single; overload;
function RegisterFunction_ArcCot_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCot') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCot'
    , _typeSINGLE // result type
    , Address_ArcCot_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcCot_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := ArcCot;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCot(const X: Double): Double; overload;
function RegisterFunction_ArcCot_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCot') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCot'
    , _typeDOUBLE // result type
    , Address_ArcCot_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcCot_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := ArcCot;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCot(const X: Extended): Extended; overload;
function RegisterFunction_ArcCot_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCot') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCot'
    , _typeEXTENDED // result type
    , Address_ArcCot_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcSec_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := ArcSec;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSec(const X: Single): Single; overload;
function RegisterFunction_ArcSec_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSec') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSec'
    , _typeSINGLE // result type
    , Address_ArcSec_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcSec_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := ArcSec;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSec(const X: Double): Double; overload;
function RegisterFunction_ArcSec_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSec') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSec'
    , _typeDOUBLE // result type
    , Address_ArcSec_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcSec_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := ArcSec;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSec(const X: Extended): Extended; overload;
function RegisterFunction_ArcSec_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSec') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSec'
    , _typeEXTENDED // result type
    , Address_ArcSec_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcCsc_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := ArcCsc;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCsc(const X: Single): Single; overload;
function RegisterFunction_ArcCsc_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCsc') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCsc'
    , _typeSINGLE // result type
    , Address_ArcCsc_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcCsc_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := ArcCsc;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCsc(const X: Double): Double; overload;
function RegisterFunction_ArcCsc_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCsc') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCsc'
    , _typeDOUBLE // result type
    , Address_ArcCsc_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcCsc_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := ArcCsc;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCsc(const X: Extended): Extended; overload;
function RegisterFunction_ArcCsc_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCsc') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCsc'
    , _typeEXTENDED // result type
    , Address_ArcCsc_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcCosh_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := ArcCosh;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCosh(const X: Single): Single; overload;
function RegisterFunction_ArcCosh_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCosh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCosh'
    , _typeSINGLE // result type
    , Address_ArcCosh_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcCosh_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := ArcCosh;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCosh(const X: Double): Double; overload;
function RegisterFunction_ArcCosh_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCosh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCosh'
    , _typeDOUBLE // result type
    , Address_ArcCosh_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcCosh_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := ArcCosh;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCosh(const X: Extended): Extended; overload;
function RegisterFunction_ArcCosh_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCosh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCosh'
    , _typeEXTENDED // result type
    , Address_ArcCosh_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcSinh_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := ArcSinh;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSinh(const X: Single): Single; overload;
function RegisterFunction_ArcSinh_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSinh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSinh'
    , _typeSINGLE // result type
    , Address_ArcSinh_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcSinh_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := ArcSinh;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSinh(const X: Double): Double; overload;
function RegisterFunction_ArcSinh_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSinh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSinh'
    , _typeDOUBLE // result type
    , Address_ArcSinh_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcSinh_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := ArcSinh;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSinh(const X: Extended): Extended; overload;
function RegisterFunction_ArcSinh_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSinh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSinh'
    , _typeEXTENDED // result type
    , Address_ArcSinh_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcTanh_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := ArcTanh;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcTanh(const X: Single): Single; overload;
function RegisterFunction_ArcTanh_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcTanh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcTanh'
    , _typeSINGLE // result type
    , Address_ArcTanh_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcTanh_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := ArcTanh;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcTanh(const X: Double): Double; overload;
function RegisterFunction_ArcTanh_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcTanh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcTanh'
    , _typeDOUBLE // result type
    , Address_ArcTanh_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcTanh_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := ArcTanh;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcTanh(const X: Extended): Extended; overload;
function RegisterFunction_ArcTanh_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcTanh') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcTanh'
    , _typeEXTENDED // result type
    , Address_ArcTanh_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcCotH_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := ArcCotH;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCotH(const X: Single): Single; overload;
function RegisterFunction_ArcCotH_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCotH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCotH'
    , _typeSINGLE // result type
    , Address_ArcCotH_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcCotH_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := ArcCotH;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCotH(const X: Double): Double; overload;
function RegisterFunction_ArcCotH_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCotH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCotH'
    , _typeDOUBLE // result type
    , Address_ArcCotH_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcCotH_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := ArcCotH;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCotH(const X: Extended): Extended; overload;
function RegisterFunction_ArcCotH_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCotH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCotH'
    , _typeEXTENDED // result type
    , Address_ArcCotH_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcSecH_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := ArcSecH;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSecH(const X: Single): Single; overload;
function RegisterFunction_ArcSecH_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSecH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSecH'
    , _typeSINGLE // result type
    , Address_ArcSecH_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcSecH_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := ArcSecH;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSecH(const X: Double): Double; overload;
function RegisterFunction_ArcSecH_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSecH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSecH'
    , _typeDOUBLE // result type
    , Address_ArcSecH_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcSecH_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := ArcSecH;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcSecH(const X: Extended): Extended; overload;
function RegisterFunction_ArcSecH_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcSecH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcSecH'
    , _typeEXTENDED // result type
    , Address_ArcSecH_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_ArcCscH_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := ArcCscH;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCscH(const X: Single): Single; overload;
function RegisterFunction_ArcCscH_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCscH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCscH'
    , _typeSINGLE // result type
    , Address_ArcCscH_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_ArcCscH_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := ArcCscH;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCscH(const X: Double): Double; overload;
function RegisterFunction_ArcCscH_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCscH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCscH'
    , _typeDOUBLE // result type
    , Address_ArcCscH_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_ArcCscH_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := ArcCscH;
  Move(P, result, SizeOf(Pointer));
end;


// function ArcCscH(const X: Extended): Extended; overload;
function RegisterFunction_ArcCscH_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ArcCscH') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ArcCscH'
    , _typeEXTENDED // result type
    , Address_ArcCscH_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_LnXP1_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := LnXP1;
  Move(P, result, SizeOf(Pointer));
end;


// function LnXP1(const X: Single): Single; overload;
function RegisterFunction_LnXP1_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('LnXP1') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'LnXP1'
    , _typeSINGLE // result type
    , Address_LnXP1_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_LnXP1_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := LnXP1;
  Move(P, result, SizeOf(Pointer));
end;


// function LnXP1(const X: Double): Double; overload;
function RegisterFunction_LnXP1_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('LnXP1') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'LnXP1'
    , _typeDOUBLE // result type
    , Address_LnXP1_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_LnXP1_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := LnXP1;
  Move(P, result, SizeOf(Pointer));
end;


// function LnXP1(const X: Extended): Extended; overload;
function RegisterFunction_LnXP1_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('LnXP1') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'LnXP1'
    , _typeEXTENDED // result type
    , Address_LnXP1_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Log10_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Log10;
  Move(P, result, SizeOf(Pointer));
end;


// function Log10(const X: Single): Single; overload;
function RegisterFunction_Log10_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Log10') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Log10'
    , _typeSINGLE // result type
    , Address_Log10_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Log10_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Log10;
  Move(P, result, SizeOf(Pointer));
end;


// function Log10(const X: Double): Double; overload;
function RegisterFunction_Log10_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Log10') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Log10'
    , _typeDOUBLE // result type
    , Address_Log10_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Log10_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Log10;
  Move(P, result, SizeOf(Pointer));
end;


// function Log10(const X: Extended): Extended; overload;
function RegisterFunction_Log10_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Log10') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Log10'
    , _typeEXTENDED // result type
    , Address_Log10_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Log2_1: Pointer;
type
  T = function (const X: Single): Single;
var
  P: T;
begin
  P := Log2;
  Move(P, result, SizeOf(Pointer));
end;


// function Log2(const X: Single): Single; overload;
function RegisterFunction_Log2_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Log2') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Log2'
    , _typeSINGLE // result type
    , Address_Log2_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Log2_2: Pointer;
type
  T = function (const X: Double): Double;
var
  P: T;
begin
  P := Log2;
  Move(P, result, SizeOf(Pointer));
end;


// function Log2(const X: Double): Double; overload;
function RegisterFunction_Log2_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Log2') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Log2'
    , _typeDOUBLE // result type
    , Address_Log2_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Log2_3: Pointer;
type
  T = function (const X: Extended): Extended;
var
  P: T;
begin
  P := Log2;
  Move(P, result, SizeOf(Pointer));
end;


// function Log2(const X: Extended): Extended; overload;
function RegisterFunction_Log2_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Log2') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Log2'
    , _typeEXTENDED // result type
    , Address_Log2_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_LogN_1: Pointer;
type
  T = function (const Base, X: Single): Single;
var
  P: T;
begin
  P := LogN;
  Move(P, result, SizeOf(Pointer));
end;


// function LogN(const Base, X: Single): Single; overload;
function RegisterFunction_LogN_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('LogN') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'LogN'
    , _typeSINGLE // result type
    , Address_LogN_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Base', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_LogN_2: Pointer;
type
  T = function (const Base, X: Double): Double;
var
  P: T;
begin
  P := LogN;
  Move(P, result, SizeOf(Pointer));
end;


// function LogN(const Base, X: Double): Double; overload;
function RegisterFunction_LogN_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('LogN') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'LogN'
    , _typeDOUBLE // result type
    , Address_LogN_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Base', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_LogN_3: Pointer;
type
  T = function (const Base, X: Extended): Extended;
var
  P: T;
begin
  P := LogN;
  Move(P, result, SizeOf(Pointer));
end;


// function LogN(const Base, X: Extended): Extended; overload;
function RegisterFunction_LogN_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('LogN') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'LogN'
    , _typeEXTENDED // result type
    , Address_LogN_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Base', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_IntPower_1: Pointer;
type
  T = function (const Base: Single; const Exponent: Integer): Single;
var
  P: T;
begin
  P := IntPower;
  Move(P, result, SizeOf(Pointer));
end;


// function IntPower(const Base: Single; const Exponent: Integer): Single; overload;
function RegisterFunction_IntPower_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IntPower') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IntPower'
    , _typeSINGLE // result type
    , Address_IntPower_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Base', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'Exponent', _typeINTEGER, _parCONST);
end;


function Address_IntPower_2: Pointer;
type
  T = function (const Base: Double; const Exponent: Integer): Double;
var
  P: T;
begin
  P := IntPower;
  Move(P, result, SizeOf(Pointer));
end;


// function IntPower(const Base: Double; const Exponent: Integer): Double; overload;
function RegisterFunction_IntPower_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IntPower') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IntPower'
    , _typeDOUBLE // result type
    , Address_IntPower_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Base', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'Exponent', _typeINTEGER, _parCONST);
end;


function Address_IntPower_3: Pointer;
type
  T = function (const Base: Extended; const Exponent: Integer): Extended;
var
  P: T;
begin
  P := IntPower;
  Move(P, result, SizeOf(Pointer));
end;


// function IntPower(const Base: Extended; const Exponent: Integer): Extended; overload;
function RegisterFunction_IntPower_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IntPower') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IntPower'
    , _typeEXTENDED // result type
    , Address_IntPower_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Base', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Exponent', _typeINTEGER, _parCONST);
end;


function Address_Power_1: Pointer;
type
  T = function (const Base, Exponent: Extended): Extended;
var
  P: T;
begin
  P := Power;
  Move(P, result, SizeOf(Pointer));
end;


// function Power(const Base, Exponent: Extended): Extended; overload;
function RegisterFunction_Power_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Power') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Power'
    , _typeEXTENDED // result type
    , Address_Power_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Base', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Exponent', _typeEXTENDED, _parCONST);
end;


function Address_Power_2: Pointer;
type
  T = function (const Base, Exponent: Double): Double;
var
  P: T;
begin
  P := Power;
  Move(P, result, SizeOf(Pointer));
end;


// function Power(const Base, Exponent: Double): Double; overload;
function RegisterFunction_Power_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Power') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Power'
    , _typeDOUBLE // result type
    , Address_Power_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Base', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'Exponent', _typeDOUBLE, _parCONST);
end;


function Address_Power_3: Pointer;
type
  T = function (const Base, Exponent: Single): Single;
var
  P: T;
begin
  P := Power;
  Move(P, result, SizeOf(Pointer));
end;


// function Power(const Base, Exponent: Single): Single; overload;
function RegisterFunction_Power_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Power') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Power'
    , _typeSINGLE // result type
    , Address_Power_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Base', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'Exponent', _typeSINGLE, _parCONST);
end;


function Address_Frexp_1: Pointer;
type
  T = procedure (const X: Single; var Mantissa: Single; var Exponent: Integer);
var
  P: T;
begin
  P := Frexp;
  Move(P, result, SizeOf(Pointer));
end;


// procedure Frexp(const X: Single; var Mantissa: Single; var Exponent: Integer); overload;
function RegisterProcedure_Frexp_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Frexp') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Frexp'
    , _typeVOID // result type
    , Address_Frexp_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'Mantissa', _typeSINGLE, _parVAR);
  compiler.RegisterParameter(result, 'Exponent', _typeINTEGER, _parVAR);
end;


function Address_Frexp_2: Pointer;
type
  T = procedure (const X: Double; var Mantissa: Double; var Exponent: Integer);
var
  P: T;
begin
  P := Frexp;
  Move(P, result, SizeOf(Pointer));
end;


// procedure Frexp(const X: Double; var Mantissa: Double; var Exponent: Integer); overload;
function RegisterProcedure_Frexp_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Frexp') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Frexp'
    , _typeVOID // result type
    , Address_Frexp_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'Mantissa', _typeDOUBLE, _parVAR);
  compiler.RegisterParameter(result, 'Exponent', _typeINTEGER, _parVAR);
end;


function Address_Frexp_3: Pointer;
type
  T = procedure (const X: Extended; var Mantissa: Extended; var Exponent: Integer);
var
  P: T;
begin
  P := Frexp;
  Move(P, result, SizeOf(Pointer));
end;


// procedure Frexp(const X: Extended; var Mantissa: Extended; var Exponent: Integer); overload;
function RegisterProcedure_Frexp_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Frexp') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Frexp'
    , _typeVOID // result type
    , Address_Frexp_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Mantissa', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'Exponent', _typeINTEGER, _parVAR);
end;


function Address_Ldexp_1: Pointer;
type
  T = function (const X: Single; const P: Integer): Single;
var
  P: T;
begin
  P := Ldexp;
  Move(P, result, SizeOf(Pointer));
end;


// function Ldexp(const X: Single; const P: Integer): Single; overload;
function RegisterFunction_Ldexp_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Ldexp') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Ldexp'
    , _typeSINGLE // result type
    , Address_Ldexp_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'P', _typeINTEGER, _parCONST);
end;


function Address_Ldexp_2: Pointer;
type
  T = function (const X: Double; const P: Integer): Double;
var
  P: T;
begin
  P := Ldexp;
  Move(P, result, SizeOf(Pointer));
end;


// function Ldexp(const X: Double; const P: Integer): Double; overload;
function RegisterFunction_Ldexp_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Ldexp') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Ldexp'
    , _typeDOUBLE // result type
    , Address_Ldexp_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'P', _typeINTEGER, _parCONST);
end;


function Address_Ldexp_3: Pointer;
type
  T = function (const X: Extended; const P: Integer): Extended;
var
  P: T;
begin
  P := Ldexp;
  Move(P, result, SizeOf(Pointer));
end;


// function Ldexp(const X: Extended; const P: Integer): Extended; overload;
function RegisterFunction_Ldexp_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Ldexp') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Ldexp'
    , _typeEXTENDED // result type
    , Address_Ldexp_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'P', _typeINTEGER, _parCONST);
end;


function Address_Ceil_1: Pointer;
type
  T = function (const X: Single): Integer;
var
  P: T;
begin
  P := Ceil;
  Move(P, result, SizeOf(Pointer));
end;


// function Ceil(const X: Single): Integer; overload;
function RegisterFunction_Ceil_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Ceil') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Ceil'
    , _typeINTEGER // result type
    , Address_Ceil_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Ceil_2: Pointer;
type
  T = function (const X: Double): Integer;
var
  P: T;
begin
  P := Ceil;
  Move(P, result, SizeOf(Pointer));
end;


// function Ceil(const X: Double): Integer; overload;
function RegisterFunction_Ceil_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Ceil') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Ceil'
    , _typeINTEGER // result type
    , Address_Ceil_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Ceil_3: Pointer;
type
  T = function (const X: Extended): Integer;
var
  P: T;
begin
  P := Ceil;
  Move(P, result, SizeOf(Pointer));
end;


// function Ceil(const X: Extended): Integer; overload;
function RegisterFunction_Ceil_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Ceil') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Ceil'
    , _typeINTEGER // result type
    , Address_Ceil_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Floor_1: Pointer;
type
  T = function (const X: Single): Integer;
var
  P: T;
begin
  P := Floor;
  Move(P, result, SizeOf(Pointer));
end;


// function Floor(const X: Single): Integer; overload;
function RegisterFunction_Floor_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Floor') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Floor'
    , _typeINTEGER // result type
    , Address_Floor_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
end;


function Address_Floor_2: Pointer;
type
  T = function (const X: Double): Integer;
var
  P: T;
begin
  P := Floor;
  Move(P, result, SizeOf(Pointer));
end;


// function Floor(const X: Double): Integer; overload;
function RegisterFunction_Floor_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Floor') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Floor'
    , _typeINTEGER // result type
    , Address_Floor_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
end;


function Address_Floor_3: Pointer;
type
  T = function (const X: Extended): Integer;
var
  P: T;
begin
  P := Floor;
  Move(P, result, SizeOf(Pointer));
end;


// function Floor(const X: Extended): Integer; overload;
function RegisterFunction_Floor_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Floor') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Floor'
    , _typeINTEGER // result type
    , Address_Floor_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
end;


function Address_Poly_1: Pointer;
type
  T = function (const X: Single; const Coefficients: array of Single): Single;
var
  P: T;
begin
  P := Poly;
  Move(P, result, SizeOf(Pointer));
end;


// function Poly(const X: Single; const Coefficients: array of Single): Single; overload;
function RegisterFunction_Poly_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Poly') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Poly'
    , _typeSINGLE // result type
    , Address_Poly_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'Coefficients', H_DYNARRAY_Single, _parCONST);
end;


function Address_Poly_2: Pointer;
type
  T = function (const X: Double; const Coefficients: array of Double): Double;
var
  P: T;
begin
  P := Poly;
  Move(P, result, SizeOf(Pointer));
end;


// function Poly(const X: Double; const Coefficients: array of Double): Double; overload;
function RegisterFunction_Poly_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Poly') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Poly'
    , _typeDOUBLE // result type
    , Address_Poly_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'Coefficients', H_DYNARRAY_Double, _parCONST);
end;


function Address_Poly_3: Pointer;
type
  T = function (const X: Extended; const Coefficients: array of Extended): Extended;
var
  P: T;
begin
  P := Poly;
  Move(P, result, SizeOf(Pointer));
end;


// function Poly(const X: Extended; const Coefficients: array of Extended): Extended; overload;
function RegisterFunction_Poly_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Poly') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Poly'
    , _typeEXTENDED // result type
    , Address_Poly_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'X', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Coefficients', H_DYNARRAY_Extended, _parCONST);
end;


function Address_Mean_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := Mean;
  Move(P, result, SizeOf(Pointer));
end;


// function Mean(const Data: array of Single): Single; overload;
function RegisterFunction_Mean_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Mean') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Mean'
    , _typeSINGLE // result type
    , Address_Mean_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_Mean_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := Mean;
  Move(P, result, SizeOf(Pointer));
end;


// function Mean(const Data: array of Double): Double; overload;
function RegisterFunction_Mean_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Mean') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Mean'
    , _typeDOUBLE // result type
    , Address_Mean_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_Mean_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := Mean;
  Move(P, result, SizeOf(Pointer));
end;


// function Mean(const Data: array of Extended): Extended; overload;
function RegisterFunction_Mean_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Mean') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Mean'
    , _typeEXTENDED // result type
    , Address_Mean_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


function Address_Sum_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := Sum;
  Move(P, result, SizeOf(Pointer));
end;


// function Sum(const Data: array of Single): Single; overload;
function RegisterFunction_Sum_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sum') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sum'
    , _typeSINGLE // result type
    , Address_Sum_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_Sum_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := Sum;
  Move(P, result, SizeOf(Pointer));
end;


// function Sum(const Data: array of Double): Double; overload;
function RegisterFunction_Sum_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sum') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sum'
    , _typeDOUBLE // result type
    , Address_Sum_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_Sum_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := Sum;
  Move(P, result, SizeOf(Pointer));
end;


// function Sum(const Data: array of Extended): Extended; overload;
function RegisterFunction_Sum_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sum') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sum'
    , _typeEXTENDED // result type
    , Address_Sum_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


// function SumInt(const Data: array of Integer): Integer;
function RegisterFunction_SumInt(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SumInt') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SumInt'
    , _typeINTEGER // result type
    , @ SumInt // address
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Integer, _parCONST);
end;


function Address_SumOfSquares_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := SumOfSquares;
  Move(P, result, SizeOf(Pointer));
end;


// function SumOfSquares(const Data: array of Single): Single; overload;
function RegisterFunction_SumOfSquares_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SumOfSquares') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SumOfSquares'
    , _typeSINGLE // result type
    , Address_SumOfSquares_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_SumOfSquares_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := SumOfSquares;
  Move(P, result, SizeOf(Pointer));
end;


// function SumOfSquares(const Data: array of Double): Double; overload;
function RegisterFunction_SumOfSquares_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SumOfSquares') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SumOfSquares'
    , _typeDOUBLE // result type
    , Address_SumOfSquares_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_SumOfSquares_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := SumOfSquares;
  Move(P, result, SizeOf(Pointer));
end;


// function SumOfSquares(const Data: array of Extended): Extended; overload;
function RegisterFunction_SumOfSquares_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SumOfSquares') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SumOfSquares'
    , _typeEXTENDED // result type
    , Address_SumOfSquares_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


function Address_SumsAndSquares_1: Pointer;
type
  T = procedure (const Data: array of Single;
  var Sum, SumOfSquares: Extended);
var
  P: T;
begin
  P := SumsAndSquares;
  Move(P, result, SizeOf(Pointer));
end;


// procedure SumsAndSquares(const Data: array of Single;  var Sum, SumOfSquares: Extended); overload;
function RegisterProcedure_SumsAndSquares_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SumsAndSquares') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SumsAndSquares'
    , _typeVOID // result type
    , Address_SumsAndSquares_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
  compiler.RegisterParameter(result, 'Sum', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'SumOfSquares', _typeEXTENDED, _parVAR);
end;


function Address_SumsAndSquares_2: Pointer;
type
  T = procedure (const Data: array of Double;
  var Sum, SumOfSquares: Extended);
var
  P: T;
begin
  P := SumsAndSquares;
  Move(P, result, SizeOf(Pointer));
end;


// procedure SumsAndSquares(const Data: array of Double;  var Sum, SumOfSquares: Extended); overload;
function RegisterProcedure_SumsAndSquares_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SumsAndSquares') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SumsAndSquares'
    , _typeVOID // result type
    , Address_SumsAndSquares_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
  compiler.RegisterParameter(result, 'Sum', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'SumOfSquares', _typeEXTENDED, _parVAR);
end;


function Address_SumsAndSquares_3: Pointer;
type
  T = procedure (const Data: array of Extended;
  var Sum, SumOfSquares: Extended);
var
  P: T;
begin
  P := SumsAndSquares;
  Move(P, result, SizeOf(Pointer));
end;


// procedure SumsAndSquares(const Data: array of Extended;  var Sum, SumOfSquares: Extended); overload;
function RegisterProcedure_SumsAndSquares_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SumsAndSquares') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SumsAndSquares'
    , _typeVOID // result type
    , Address_SumsAndSquares_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
  compiler.RegisterParameter(result, 'Sum', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'SumOfSquares', _typeEXTENDED, _parVAR);
end;


function Address_MinValue_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := MinValue;
  Move(P, result, SizeOf(Pointer));
end;


// function MinValue(const Data: array of Single): Single; overload;
function RegisterFunction_MinValue_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MinValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MinValue'
    , _typeSINGLE // result type
    , Address_MinValue_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_MinValue_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := MinValue;
  Move(P, result, SizeOf(Pointer));
end;


// function MinValue(const Data: array of Double): Double; overload;
function RegisterFunction_MinValue_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MinValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MinValue'
    , _typeDOUBLE // result type
    , Address_MinValue_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_MinValue_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := MinValue;
  Move(P, result, SizeOf(Pointer));
end;


// function MinValue(const Data: array of Extended): Extended; overload;
function RegisterFunction_MinValue_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MinValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MinValue'
    , _typeEXTENDED // result type
    , Address_MinValue_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


// function MinIntValue(const Data: array of Integer): Integer;
function RegisterFunction_MinIntValue(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MinIntValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MinIntValue'
    , _typeINTEGER // result type
    , @ MinIntValue // address
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Integer, _parCONST);
end;


function Address_Min_1: Pointer;
type
  T = function (const A, B: Integer): Integer;
var
  P: T;
begin
  P := Min;
  Move(P, result, SizeOf(Pointer));
end;


// function Min(const A, B: Integer): Integer; overload; inline;
function RegisterFunction_Min_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Min') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Min'
    , _typeINTEGER // result type
    , Address_Min_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeINTEGER, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeINTEGER, _parCONST);
end;


function Address_Min_2: Pointer;
type
  T = function (const A, B: Int64): Int64;
var
  P: T;
begin
  P := Min;
  Move(P, result, SizeOf(Pointer));
end;


// function Min(const A, B: Int64): Int64; overload; inline;
function RegisterFunction_Min_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Min') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Min'
    , _typeINT64 // result type
    , Address_Min_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeINT64, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeINT64, _parCONST);
end;


function Address_Min_3: Pointer;
type
  T = function (const A, B: UInt64): UInt64;
var
  P: T;
begin
  P := Min;
  Move(P, result, SizeOf(Pointer));
end;


// function Min(const A, B: UInt64): UInt64; overload; inline;
function RegisterFunction_Min_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Min') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Min'
    , _typeUINT64 // result type
    , Address_Min_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeUINT64, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeUINT64, _parCONST);
end;


function Address_Min_4: Pointer;
type
  T = function (const A, B: Single): Single;
var
  P: T;
begin
  P := Min;
  Move(P, result, SizeOf(Pointer));
end;


// function Min(const A, B: Single): Single; overload; inline;
function RegisterFunction_Min_4(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Min') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Min'
    , _typeSINGLE // result type
    , Address_Min_4 // address
    , _ccREGISTER
    , 4 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeSINGLE, _parCONST);
end;


function Address_Min_5: Pointer;
type
  T = function (const A, B: Double): Double;
var
  P: T;
begin
  P := Min;
  Move(P, result, SizeOf(Pointer));
end;


// function Min(const A, B: Double): Double; overload; inline;
function RegisterFunction_Min_5(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Min') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Min'
    , _typeDOUBLE // result type
    , Address_Min_5 // address
    , _ccREGISTER
    , 5 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeDOUBLE, _parCONST);
end;


function Address_Min_6: Pointer;
type
  T = function (const A, B: Extended): Extended;
var
  P: T;
begin
  P := Min;
  Move(P, result, SizeOf(Pointer));
end;


// function Min(const A, B: Extended): Extended; overload; inline;
function RegisterFunction_Min_6(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Min') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Min'
    , _typeEXTENDED // result type
    , Address_Min_6 // address
    , _ccREGISTER
    , 6 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeEXTENDED, _parCONST);
end;


function Address_MaxValue_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := MaxValue;
  Move(P, result, SizeOf(Pointer));
end;


// function MaxValue(const Data: array of Single): Single; overload;
function RegisterFunction_MaxValue_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MaxValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MaxValue'
    , _typeSINGLE // result type
    , Address_MaxValue_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_MaxValue_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := MaxValue;
  Move(P, result, SizeOf(Pointer));
end;


// function MaxValue(const Data: array of Double): Double; overload;
function RegisterFunction_MaxValue_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MaxValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MaxValue'
    , _typeDOUBLE // result type
    , Address_MaxValue_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_MaxValue_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := MaxValue;
  Move(P, result, SizeOf(Pointer));
end;


// function MaxValue(const Data: array of Extended): Extended; overload;
function RegisterFunction_MaxValue_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MaxValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MaxValue'
    , _typeEXTENDED // result type
    , Address_MaxValue_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


// function MaxIntValue(const Data: array of Integer): Integer;
function RegisterFunction_MaxIntValue(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MaxIntValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MaxIntValue'
    , _typeINTEGER // result type
    , @ MaxIntValue // address
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Integer, _parCONST);
end;


function Address_Max_1: Pointer;
type
  T = function (const A, B: Integer): Integer;
var
  P: T;
begin
  P := Max;
  Move(P, result, SizeOf(Pointer));
end;


// function Max(const A, B: Integer): Integer; overload; inline;
function RegisterFunction_Max_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Max') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Max'
    , _typeINTEGER // result type
    , Address_Max_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeINTEGER, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeINTEGER, _parCONST);
end;


function Address_Max_2: Pointer;
type
  T = function (const A, B: Int64): Int64;
var
  P: T;
begin
  P := Max;
  Move(P, result, SizeOf(Pointer));
end;


// function Max(const A, B: Int64): Int64; overload; inline;
function RegisterFunction_Max_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Max') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Max'
    , _typeINT64 // result type
    , Address_Max_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeINT64, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeINT64, _parCONST);
end;


function Address_Max_3: Pointer;
type
  T = function (const A, B: UInt64): UInt64;
var
  P: T;
begin
  P := Max;
  Move(P, result, SizeOf(Pointer));
end;


// function Max(const A, B: UInt64): UInt64; overload; inline;
function RegisterFunction_Max_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Max') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Max'
    , _typeUINT64 // result type
    , Address_Max_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeUINT64, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeUINT64, _parCONST);
end;


function Address_Max_4: Pointer;
type
  T = function (const A, B: Single): Single;
var
  P: T;
begin
  P := Max;
  Move(P, result, SizeOf(Pointer));
end;


// function Max(const A, B: Single): Single; overload; inline;
function RegisterFunction_Max_4(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Max') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Max'
    , _typeSINGLE // result type
    , Address_Max_4 // address
    , _ccREGISTER
    , 4 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeSINGLE, _parCONST);
end;


function Address_Max_5: Pointer;
type
  T = function (const A, B: Double): Double;
var
  P: T;
begin
  P := Max;
  Move(P, result, SizeOf(Pointer));
end;


// function Max(const A, B: Double): Double; overload; inline;
function RegisterFunction_Max_5(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Max') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Max'
    , _typeDOUBLE // result type
    , Address_Max_5 // address
    , _ccREGISTER
    , 5 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeDOUBLE, _parCONST);
end;


function Address_Max_6: Pointer;
type
  T = function (const A, B: Extended): Extended;
var
  P: T;
begin
  P := Max;
  Move(P, result, SizeOf(Pointer));
end;


// function Max(const A, B: Extended): Extended; overload; inline;
function RegisterFunction_Max_6(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Max') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Max'
    , _typeEXTENDED // result type
    , Address_Max_6 // address
    , _ccREGISTER
    , 6 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeEXTENDED, _parCONST);
end;


function Address_StdDev_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := StdDev;
  Move(P, result, SizeOf(Pointer));
end;


// function StdDev(const Data: array of Single): Single; overload;
function RegisterFunction_StdDev_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('StdDev') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'StdDev'
    , _typeSINGLE // result type
    , Address_StdDev_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_StdDev_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := StdDev;
  Move(P, result, SizeOf(Pointer));
end;


// function StdDev(const Data: array of Double): Double; overload;
function RegisterFunction_StdDev_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('StdDev') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'StdDev'
    , _typeDOUBLE // result type
    , Address_StdDev_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_StdDev_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := StdDev;
  Move(P, result, SizeOf(Pointer));
end;


// function StdDev(const Data: array of Extended): Extended; overload;
function RegisterFunction_StdDev_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('StdDev') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'StdDev'
    , _typeEXTENDED // result type
    , Address_StdDev_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


function Address_MeanAndStdDev_1: Pointer;
type
  T = procedure (const Data: array of Single; var Mean, StdDev: Single);
var
  P: T;
begin
  P := MeanAndStdDev;
  Move(P, result, SizeOf(Pointer));
end;


// procedure MeanAndStdDev(const Data: array of Single; var Mean, StdDev: Single); overload;
function RegisterProcedure_MeanAndStdDev_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MeanAndStdDev') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MeanAndStdDev'
    , _typeVOID // result type
    , Address_MeanAndStdDev_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
  compiler.RegisterParameter(result, 'Mean', _typeSINGLE, _parVAR);
  compiler.RegisterParameter(result, 'StdDev', _typeSINGLE, _parVAR);
end;


function Address_MeanAndStdDev_2: Pointer;
type
  T = procedure (const Data: array of Double; var Mean, StdDev: Double);
var
  P: T;
begin
  P := MeanAndStdDev;
  Move(P, result, SizeOf(Pointer));
end;


// procedure MeanAndStdDev(const Data: array of Double; var Mean, StdDev: Double); overload;
function RegisterProcedure_MeanAndStdDev_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MeanAndStdDev') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MeanAndStdDev'
    , _typeVOID // result type
    , Address_MeanAndStdDev_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
  compiler.RegisterParameter(result, 'Mean', _typeDOUBLE, _parVAR);
  compiler.RegisterParameter(result, 'StdDev', _typeDOUBLE, _parVAR);
end;


function Address_MeanAndStdDev_3: Pointer;
type
  T = procedure (const Data: array of Extended; var Mean, StdDev: Extended);
var
  P: T;
begin
  P := MeanAndStdDev;
  Move(P, result, SizeOf(Pointer));
end;


// procedure MeanAndStdDev(const Data: array of Extended; var Mean, StdDev: Extended); overload;
function RegisterProcedure_MeanAndStdDev_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MeanAndStdDev') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MeanAndStdDev'
    , _typeVOID // result type
    , Address_MeanAndStdDev_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
  compiler.RegisterParameter(result, 'Mean', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'StdDev', _typeEXTENDED, _parVAR);
end;


function Address_PopnStdDev_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := PopnStdDev;
  Move(P, result, SizeOf(Pointer));
end;


// function PopnStdDev(const Data: array of Single): Single; overload;
function RegisterFunction_PopnStdDev_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('PopnStdDev') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'PopnStdDev'
    , _typeSINGLE // result type
    , Address_PopnStdDev_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_PopnStdDev_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := PopnStdDev;
  Move(P, result, SizeOf(Pointer));
end;


// function PopnStdDev(const Data: array of Double): Double; overload;
function RegisterFunction_PopnStdDev_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('PopnStdDev') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'PopnStdDev'
    , _typeDOUBLE // result type
    , Address_PopnStdDev_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_PopnStdDev_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := PopnStdDev;
  Move(P, result, SizeOf(Pointer));
end;


// function PopnStdDev(const Data: array of Extended): Extended; overload;
function RegisterFunction_PopnStdDev_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('PopnStdDev') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'PopnStdDev'
    , _typeEXTENDED // result type
    , Address_PopnStdDev_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


function Address_Variance_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := Variance;
  Move(P, result, SizeOf(Pointer));
end;


// function Variance(const Data: array of Single): Single; overload;
function RegisterFunction_Variance_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Variance') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Variance'
    , _typeSINGLE // result type
    , Address_Variance_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_Variance_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := Variance;
  Move(P, result, SizeOf(Pointer));
end;


// function Variance(const Data: array of Double): Double; overload;
function RegisterFunction_Variance_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Variance') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Variance'
    , _typeDOUBLE // result type
    , Address_Variance_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_Variance_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := Variance;
  Move(P, result, SizeOf(Pointer));
end;


// function Variance(const Data: array of Extended): Extended; overload;
function RegisterFunction_Variance_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Variance') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Variance'
    , _typeEXTENDED // result type
    , Address_Variance_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


function Address_PopnVariance_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := PopnVariance;
  Move(P, result, SizeOf(Pointer));
end;


// function PopnVariance(const Data: array of Single): Single; overload;
function RegisterFunction_PopnVariance_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('PopnVariance') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'PopnVariance'
    , _typeSINGLE // result type
    , Address_PopnVariance_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_PopnVariance_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := PopnVariance;
  Move(P, result, SizeOf(Pointer));
end;


// function PopnVariance(const Data: array of Double): Double; overload;
function RegisterFunction_PopnVariance_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('PopnVariance') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'PopnVariance'
    , _typeDOUBLE // result type
    , Address_PopnVariance_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_PopnVariance_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := PopnVariance;
  Move(P, result, SizeOf(Pointer));
end;


// function PopnVariance(const Data: array of Extended): Extended; overload;
function RegisterFunction_PopnVariance_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('PopnVariance') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'PopnVariance'
    , _typeEXTENDED // result type
    , Address_PopnVariance_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


function Address_TotalVariance_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := TotalVariance;
  Move(P, result, SizeOf(Pointer));
end;


// function TotalVariance(const Data: array of Single): Single; overload;
function RegisterFunction_TotalVariance_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('TotalVariance') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'TotalVariance'
    , _typeSINGLE // result type
    , Address_TotalVariance_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_TotalVariance_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := TotalVariance;
  Move(P, result, SizeOf(Pointer));
end;


// function TotalVariance(const Data: array of Double): Double; overload;
function RegisterFunction_TotalVariance_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('TotalVariance') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'TotalVariance'
    , _typeDOUBLE // result type
    , Address_TotalVariance_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_TotalVariance_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := TotalVariance;
  Move(P, result, SizeOf(Pointer));
end;


// function TotalVariance(const Data: array of Extended): Extended; overload;
function RegisterFunction_TotalVariance_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('TotalVariance') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'TotalVariance'
    , _typeEXTENDED // result type
    , Address_TotalVariance_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


function Address_Norm_1: Pointer;
type
  T = function (const Data: array of Single): Single;
var
  P: T;
begin
  P := Norm;
  Move(P, result, SizeOf(Pointer));
end;


// function Norm(const Data: array of Single): Single; overload;
function RegisterFunction_Norm_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Norm') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Norm'
    , _typeSINGLE // result type
    , Address_Norm_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Single, _parCONST);
end;


function Address_Norm_2: Pointer;
type
  T = function (const Data: array of Double): Double;
var
  P: T;
begin
  P := Norm;
  Move(P, result, SizeOf(Pointer));
end;


// function Norm(const Data: array of Double): Double; overload;
function RegisterFunction_Norm_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Norm') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Norm'
    , _typeDOUBLE // result type
    , Address_Norm_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
end;


function Address_Norm_3: Pointer;
type
  T = function (const Data: array of Extended): Extended;
var
  P: T;
begin
  P := Norm;
  Move(P, result, SizeOf(Pointer));
end;


// function Norm(const Data: array of Extended): Extended; overload;
function RegisterFunction_Norm_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Norm') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Norm'
    , _typeEXTENDED // result type
    , Address_Norm_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Extended, _parCONST);
end;


// procedure MomentSkewKurtosis(const Data: array of Double;  var M1, M2, M3, M4, Skew, Kurtosis: Extended);
function RegisterProcedure_MomentSkewKurtosis(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('MomentSkewKurtosis') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'MomentSkewKurtosis'
    , _typeVOID // result type
    , @ MomentSkewKurtosis // address
    );
  compiler.RegisterParameter(result, 'Data', H_DYNARRAY_Double, _parCONST);
  compiler.RegisterParameter(result, 'M1', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'M2', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'M3', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'M4', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'Skew', _typeEXTENDED, _parVAR);
  compiler.RegisterParameter(result, 'Kurtosis', _typeEXTENDED, _parVAR);
end;


function Address_RandG_1: Pointer;
type
  T = function (Mean, StdDev: Single): Single;
var
  P: T;
begin
  P := RandG;
  Move(P, result, SizeOf(Pointer));
end;


// function RandG(Mean, StdDev: Single): Single; overload;
function RegisterFunction_RandG_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RandG') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RandG'
    , _typeSINGLE // result type
    , Address_RandG_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Mean', _typeSINGLE, _parVAL);
  compiler.RegisterParameter(result, 'StdDev', _typeSINGLE, _parVAL);
end;


function Address_RandG_2: Pointer;
type
  T = function (Mean, StdDev: Double): Double;
var
  P: T;
begin
  P := RandG;
  Move(P, result, SizeOf(Pointer));
end;


// function RandG(Mean, StdDev: Double): Double; overload;
function RegisterFunction_RandG_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RandG') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RandG'
    , _typeDOUBLE // result type
    , Address_RandG_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Mean', _typeDOUBLE, _parVAL);
  compiler.RegisterParameter(result, 'StdDev', _typeDOUBLE, _parVAL);
end;


function Address_RandG_3: Pointer;
type
  T = function (Mean, StdDev: Extended): Extended;
var
  P: T;
begin
  P := RandG;
  Move(P, result, SizeOf(Pointer));
end;


// function RandG(Mean, StdDev: Extended): Extended; overload;
function RegisterFunction_RandG_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RandG') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RandG'
    , _typeEXTENDED // result type
    , Address_RandG_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'Mean', _typeEXTENDED, _parVAL);
  compiler.RegisterParameter(result, 'StdDev', _typeEXTENDED, _parVAL);
end;


function Address_IsNan_1: Pointer;
type
  T = function (const AValue: Single): Boolean;
var
  P: T;
begin
  P := IsNan;
  Move(P, result, SizeOf(Pointer));
end;


// function IsNan(const AValue: Single): Boolean; overload;
function RegisterFunction_IsNan_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IsNan') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IsNan'
    , _typeBOOLEAN // result type
    , Address_IsNan_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeSINGLE, _parCONST);
end;


function Address_IsNan_2: Pointer;
type
  T = function (const AValue: Double): Boolean;
var
  P: T;
begin
  P := IsNan;
  Move(P, result, SizeOf(Pointer));
end;


// function IsNan(const AValue: Double): Boolean; overload;
function RegisterFunction_IsNan_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IsNan') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IsNan'
    , _typeBOOLEAN // result type
    , Address_IsNan_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeDOUBLE, _parCONST);
end;


function Address_IsNan_3: Pointer;
type
  T = function (const AValue: Extended): Boolean;
var
  P: T;
begin
  P := IsNan;
  Move(P, result, SizeOf(Pointer));
end;


// function IsNan(const AValue: Extended): Boolean; overload;
function RegisterFunction_IsNan_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IsNan') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IsNan'
    , _typeBOOLEAN // result type
    , Address_IsNan_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeEXTENDED, _parCONST);
end;


function Address_IsInfinite_1: Pointer;
type
  T = function (const AValue: Single): Boolean;
var
  P: T;
begin
  P := IsInfinite;
  Move(P, result, SizeOf(Pointer));
end;


// function IsInfinite(const AValue: Single): Boolean; overload;
function RegisterFunction_IsInfinite_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IsInfinite') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IsInfinite'
    , _typeBOOLEAN // result type
    , Address_IsInfinite_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeSINGLE, _parCONST);
end;


function Address_IsInfinite_2: Pointer;
type
  T = function (const AValue: Double): Boolean;
var
  P: T;
begin
  P := IsInfinite;
  Move(P, result, SizeOf(Pointer));
end;


// function IsInfinite(const AValue: Double): Boolean; overload;
function RegisterFunction_IsInfinite_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IsInfinite') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IsInfinite'
    , _typeBOOLEAN // result type
    , Address_IsInfinite_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeDOUBLE, _parCONST);
end;


function Address_IsInfinite_3: Pointer;
type
  T = function (const AValue: Extended): Boolean;
var
  P: T;
begin
  P := IsInfinite;
  Move(P, result, SizeOf(Pointer));
end;


// function IsInfinite(const AValue: Extended): Boolean; overload;
function RegisterFunction_IsInfinite_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IsInfinite') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IsInfinite'
    , _typeBOOLEAN // result type
    , Address_IsInfinite_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeEXTENDED, _parCONST);
end;


function RegisterConstant__ZeroValue(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ZeroValue') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'ZeroValue', 0);
end;


function Address_Sign_1: Pointer;
type
  T = function (const AValue: Integer): TValueSign;
var
  P: T;
begin
  P := Sign;
  Move(P, result, SizeOf(Pointer));
end;


// function Sign(const AValue: Integer): TValueSign; overload;
function RegisterFunction_Sign_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sign') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sign'
    , 'TValueSign' // result type
    , Address_Sign_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeINTEGER, _parCONST);
end;


function Address_Sign_2: Pointer;
type
  T = function (const AValue: Int64): TValueSign;
var
  P: T;
begin
  P := Sign;
  Move(P, result, SizeOf(Pointer));
end;


// function Sign(const AValue: Int64): TValueSign; overload;
function RegisterFunction_Sign_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sign') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sign'
    , 'TValueSign' // result type
    , Address_Sign_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeINT64, _parCONST);
end;


function Address_Sign_3: Pointer;
type
  T = function (const AValue: Single): TValueSign;
var
  P: T;
begin
  P := Sign;
  Move(P, result, SizeOf(Pointer));
end;


// function Sign(const AValue: Single): TValueSign; overload;
function RegisterFunction_Sign_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sign') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sign'
    , 'TValueSign' // result type
    , Address_Sign_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeSINGLE, _parCONST);
end;


function Address_Sign_4: Pointer;
type
  T = function (const AValue: Double): TValueSign;
var
  P: T;
begin
  P := Sign;
  Move(P, result, SizeOf(Pointer));
end;


// function Sign(const AValue: Double): TValueSign; overload;
function RegisterFunction_Sign_4(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sign') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sign'
    , 'TValueSign' // result type
    , Address_Sign_4 // address
    , _ccREGISTER
    , 4 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeDOUBLE, _parCONST);
end;


function Address_Sign_5: Pointer;
type
  T = function (const AValue: Extended): TValueSign;
var
  P: T;
begin
  P := Sign;
  Move(P, result, SizeOf(Pointer));
end;


// function Sign(const AValue: Extended): TValueSign; overload;
function RegisterFunction_Sign_5(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Sign') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Sign'
    , 'TValueSign' // result type
    , Address_Sign_5 // address
    , _ccREGISTER
    , 5 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeEXTENDED, _parCONST);
end;


function Address_CompareValue_1: Pointer;
type
  T = function (const A, B: Extended; Epsilon: Extended = 0): TValueRelationship;
var
  P: T;
begin
  P := CompareValue;
  Move(P, result, SizeOf(Pointer));
end;


// function CompareValue(const A, B: Extended; Epsilon: Extended = 0): TValueRelationship; overload;
function RegisterFunction_CompareValue_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CompareValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CompareValue'
    , 'TValueRelationship' // result type
    , Address_CompareValue_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Epsilon', _typeEXTENDED, _parVAL, true, '0');
end;


function Address_CompareValue_2: Pointer;
type
  T = function (const A, B: Double; Epsilon: Double = 0): TValueRelationship;
var
  P: T;
begin
  P := CompareValue;
  Move(P, result, SizeOf(Pointer));
end;


// function CompareValue(const A, B: Double; Epsilon: Double = 0): TValueRelationship; overload;
function RegisterFunction_CompareValue_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CompareValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CompareValue'
    , 'TValueRelationship' // result type
    , Address_CompareValue_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'Epsilon', _typeDOUBLE, _parVAL, true, '0');
end;


function Address_CompareValue_3: Pointer;
type
  T = function (const A, B: Single; Epsilon: Single = 0): TValueRelationship;
var
  P: T;
begin
  P := CompareValue;
  Move(P, result, SizeOf(Pointer));
end;


// function CompareValue(const A, B: Single; Epsilon: Single = 0): TValueRelationship; overload;
function RegisterFunction_CompareValue_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CompareValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CompareValue'
    , 'TValueRelationship' // result type
    , Address_CompareValue_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'Epsilon', _typeSINGLE, _parVAL, true, '0');
end;


function Address_CompareValue_4: Pointer;
type
  T = function (const A, B: Integer): TValueRelationship;
var
  P: T;
begin
  P := CompareValue;
  Move(P, result, SizeOf(Pointer));
end;


// function CompareValue(const A, B: Integer): TValueRelationship; overload;
function RegisterFunction_CompareValue_4(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CompareValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CompareValue'
    , 'TValueRelationship' // result type
    , Address_CompareValue_4 // address
    , _ccREGISTER
    , 4 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeINTEGER, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeINTEGER, _parCONST);
end;


function Address_CompareValue_5: Pointer;
type
  T = function (const A, B: Int64): TValueRelationship;
var
  P: T;
begin
  P := CompareValue;
  Move(P, result, SizeOf(Pointer));
end;


// function CompareValue(const A, B: Int64): TValueRelationship; overload;
function RegisterFunction_CompareValue_5(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CompareValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CompareValue'
    , 'TValueRelationship' // result type
    , Address_CompareValue_5 // address
    , _ccREGISTER
    , 5 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeINT64, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeINT64, _parCONST);
end;


function Address_CompareValue_6: Pointer;
type
  T = function (const A, B: UInt64): TValueRelationship;
var
  P: T;
begin
  P := CompareValue;
  Move(P, result, SizeOf(Pointer));
end;


// function CompareValue(const A, B: UInt64): TValueRelationship; overload;
function RegisterFunction_CompareValue_6(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('CompareValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'CompareValue'
    , 'TValueRelationship' // result type
    , Address_CompareValue_6 // address
    , _ccREGISTER
    , 6 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeUINT64, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeUINT64, _parCONST);
end;


function Address_SameValue_1: Pointer;
type
  T = function (const A, B: Extended; Epsilon: Extended = 0): Boolean;
var
  P: T;
begin
  P := SameValue;
  Move(P, result, SizeOf(Pointer));
end;


// function SameValue(const A, B: Extended; Epsilon: Extended = 0): Boolean; overload;
function RegisterFunction_SameValue_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SameValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SameValue'
    , _typeBOOLEAN // result type
    , Address_SameValue_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Epsilon', _typeEXTENDED, _parVAL, true, '0');
end;


function Address_SameValue_2: Pointer;
type
  T = function (const A, B: Double; Epsilon: Double = 0): Boolean;
var
  P: T;
begin
  P := SameValue;
  Move(P, result, SizeOf(Pointer));
end;


// function SameValue(const A, B: Double; Epsilon: Double = 0): Boolean; overload;
function RegisterFunction_SameValue_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SameValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SameValue'
    , _typeBOOLEAN // result type
    , Address_SameValue_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'Epsilon', _typeDOUBLE, _parVAL, true, '0');
end;


function Address_SameValue_3: Pointer;
type
  T = function (const A, B: Single; Epsilon: Single = 0): Boolean;
var
  P: T;
begin
  P := SameValue;
  Move(P, result, SizeOf(Pointer));
end;


// function SameValue(const A, B: Single; Epsilon: Single = 0): Boolean; overload;
function RegisterFunction_SameValue_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SameValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SameValue'
    , _typeBOOLEAN // result type
    , Address_SameValue_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'B', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'Epsilon', _typeSINGLE, _parVAL, true, '0');
end;


function Address_IsZero_1: Pointer;
type
  T = function (const A: Extended; Epsilon: Extended = 0): Boolean;
var
  P: T;
begin
  P := IsZero;
  Move(P, result, SizeOf(Pointer));
end;


// function IsZero(const A: Extended; Epsilon: Extended = 0): Boolean; overload;
function RegisterFunction_IsZero_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IsZero') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IsZero'
    , _typeBOOLEAN // result type
    , Address_IsZero_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Epsilon', _typeEXTENDED, _parVAL, true, '0');
end;


function Address_IsZero_2: Pointer;
type
  T = function (const A: Double; Epsilon: Double = 0): Boolean;
var
  P: T;
begin
  P := IsZero;
  Move(P, result, SizeOf(Pointer));
end;


// function IsZero(const A: Double; Epsilon: Double = 0): Boolean; overload;
function RegisterFunction_IsZero_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IsZero') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IsZero'
    , _typeBOOLEAN // result type
    , Address_IsZero_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'Epsilon', _typeDOUBLE, _parVAL, true, '0');
end;


function Address_IsZero_3: Pointer;
type
  T = function (const A: Single; Epsilon: Single = 0): Boolean;
var
  P: T;
begin
  P := IsZero;
  Move(P, result, SizeOf(Pointer));
end;


// function IsZero(const A: Single; Epsilon: Single = 0): Boolean; overload;
function RegisterFunction_IsZero_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IsZero') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IsZero'
    , _typeBOOLEAN // result type
    , Address_IsZero_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'A', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'Epsilon', _typeSINGLE, _parVAL, true, '0');
end;


function Address_IfThen_1: Pointer;
type
  T = function (AValue: Boolean; const ATrue: Integer; const AFalse: Integer = 0): Integer;
var
  P: T;
begin
  P := IfThen;
  Move(P, result, SizeOf(Pointer));
end;


// function IfThen(AValue: Boolean; const ATrue: Integer; const AFalse: Integer = 0): Integer; overload; inline;
function RegisterFunction_IfThen_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IfThen') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IfThen'
    , _typeINTEGER // result type
    , Address_IfThen_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeBOOLEAN, _parVAL);
  compiler.RegisterParameter(result, 'ATrue', _typeINTEGER, _parCONST);
  compiler.RegisterParameter(result, 'AFalse', _typeINTEGER, _parCONST, true, '0');
end;


function Address_IfThen_2: Pointer;
type
  T = function (AValue: Boolean; const ATrue: Int64; const AFalse: Int64 = 0): Int64;
var
  P: T;
begin
  P := IfThen;
  Move(P, result, SizeOf(Pointer));
end;


// function IfThen(AValue: Boolean; const ATrue: Int64; const AFalse: Int64 = 0): Int64; overload; inline;
function RegisterFunction_IfThen_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IfThen') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IfThen'
    , _typeINT64 // result type
    , Address_IfThen_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeBOOLEAN, _parVAL);
  compiler.RegisterParameter(result, 'ATrue', _typeINT64, _parCONST);
  compiler.RegisterParameter(result, 'AFalse', _typeINT64, _parCONST, true, '0');
end;


function Address_IfThen_3: Pointer;
type
  T = function (AValue: Boolean; const ATrue: UInt64; const AFalse: UInt64 = 0): UInt64;
var
  P: T;
begin
  P := IfThen;
  Move(P, result, SizeOf(Pointer));
end;


// function IfThen(AValue: Boolean; const ATrue: UInt64; const AFalse: UInt64 = 0): UInt64; overload; inline;
function RegisterFunction_IfThen_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IfThen') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IfThen'
    , _typeUINT64 // result type
    , Address_IfThen_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeBOOLEAN, _parVAL);
  compiler.RegisterParameter(result, 'ATrue', _typeUINT64, _parCONST);
  compiler.RegisterParameter(result, 'AFalse', _typeUINT64, _parCONST, true, '0');
end;


function Address_IfThen_4: Pointer;
type
  T = function (AValue: Boolean; const ATrue: Single; const AFalse: Single = 0.0): Single;
var
  P: T;
begin
  P := IfThen;
  Move(P, result, SizeOf(Pointer));
end;


// function IfThen(AValue: Boolean; const ATrue: Single; const AFalse: Single = 0.0): Single; overload; inline;
function RegisterFunction_IfThen_4(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IfThen') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IfThen'
    , _typeSINGLE // result type
    , Address_IfThen_4 // address
    , _ccREGISTER
    , 4 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeBOOLEAN, _parVAL);
  compiler.RegisterParameter(result, 'ATrue', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'AFalse', _typeSINGLE, _parCONST, true, '0.0');
end;


function Address_IfThen_5: Pointer;
type
  T = function (AValue: Boolean; const ATrue: Double; const AFalse: Double = 0.0): Double;
var
  P: T;
begin
  P := IfThen;
  Move(P, result, SizeOf(Pointer));
end;


// function IfThen(AValue: Boolean; const ATrue: Double; const AFalse: Double = 0.0): Double; overload; inline;
function RegisterFunction_IfThen_5(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IfThen') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IfThen'
    , _typeDOUBLE // result type
    , Address_IfThen_5 // address
    , _ccREGISTER
    , 5 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeBOOLEAN, _parVAL);
  compiler.RegisterParameter(result, 'ATrue', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'AFalse', _typeDOUBLE, _parCONST, true, '0.0');
end;


function Address_IfThen_6: Pointer;
type
  T = function (AValue: Boolean; const ATrue: Extended; const AFalse: Extended = 0.0): Extended;
var
  P: T;
begin
  P := IfThen;
  Move(P, result, SizeOf(Pointer));
end;


// function IfThen(AValue: Boolean; const ATrue: Extended; const AFalse: Extended = 0.0): Extended; overload; inline;
function RegisterFunction_IfThen_6(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('IfThen') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'IfThen'
    , _typeEXTENDED // result type
    , Address_IfThen_6 // address
    , _ccREGISTER
    , 6 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeBOOLEAN, _parVAL);
  compiler.RegisterParameter(result, 'ATrue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'AFalse', _typeEXTENDED, _parCONST, true, '0.0');
end;


// function RandomRange(const AFrom, ATo: Integer): Integer;
function RegisterFunction_RandomRange(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RandomRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RandomRange'
    , _typeINTEGER // result type
    , @ RandomRange // address
    );
  compiler.RegisterParameter(result, 'AFrom', _typeINTEGER, _parCONST);
  compiler.RegisterParameter(result, 'ATo', _typeINTEGER, _parCONST);
end;


function Address_RandomFrom_1: Pointer;
type
  T = function (const AValues: array of Integer): Integer;
var
  P: T;
begin
  P := RandomFrom;
  Move(P, result, SizeOf(Pointer));
end;


// function RandomFrom(const AValues: array of Integer): Integer; overload;
function RegisterFunction_RandomFrom_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RandomFrom') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RandomFrom'
    , _typeINTEGER // result type
    , Address_RandomFrom_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'AValues', H_DYNARRAY_Integer, _parCONST);
end;


function Address_RandomFrom_2: Pointer;
type
  T = function (const AValues: array of Int64): Int64;
var
  P: T;
begin
  P := RandomFrom;
  Move(P, result, SizeOf(Pointer));
end;


// function RandomFrom(const AValues: array of Int64): Int64; overload;
function RegisterFunction_RandomFrom_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RandomFrom') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RandomFrom'
    , _typeINT64 // result type
    , Address_RandomFrom_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'AValues', H_DYNARRAY_Int64, _parCONST);
end;


function Address_RandomFrom_3: Pointer;
type
  T = function (const AValues: array of UInt64): UInt64;
var
  P: T;
begin
  P := RandomFrom;
  Move(P, result, SizeOf(Pointer));
end;


// function RandomFrom(const AValues: array of UInt64): UInt64; overload;
function RegisterFunction_RandomFrom_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RandomFrom') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RandomFrom'
    , _typeUINT64 // result type
    , Address_RandomFrom_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'AValues', H_DYNARRAY_UInt64, _parCONST);
end;


function Address_RandomFrom_4: Pointer;
type
  T = function (const AValues: array of Single): Single;
var
  P: T;
begin
  P := RandomFrom;
  Move(P, result, SizeOf(Pointer));
end;


// function RandomFrom(const AValues: array of Single): Single; overload;
function RegisterFunction_RandomFrom_4(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RandomFrom') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RandomFrom'
    , _typeSINGLE // result type
    , Address_RandomFrom_4 // address
    , _ccREGISTER
    , 4 // overloaded
    );
  compiler.RegisterParameter(result, 'AValues', H_DYNARRAY_Single, _parCONST);
end;


function Address_RandomFrom_5: Pointer;
type
  T = function (const AValues: array of Double): Double;
var
  P: T;
begin
  P := RandomFrom;
  Move(P, result, SizeOf(Pointer));
end;


// function RandomFrom(const AValues: array of Double): Double; overload;
function RegisterFunction_RandomFrom_5(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RandomFrom') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RandomFrom'
    , _typeDOUBLE // result type
    , Address_RandomFrom_5 // address
    , _ccREGISTER
    , 5 // overloaded
    );
  compiler.RegisterParameter(result, 'AValues', H_DYNARRAY_Double, _parCONST);
end;


function Address_RandomFrom_6: Pointer;
type
  T = function (const AValues: array of Extended): Extended;
var
  P: T;
begin
  P := RandomFrom;
  Move(P, result, SizeOf(Pointer));
end;


// function RandomFrom(const AValues: array of Extended): Extended; overload;
function RegisterFunction_RandomFrom_6(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RandomFrom') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RandomFrom'
    , _typeEXTENDED // result type
    , Address_RandomFrom_6 // address
    , _ccREGISTER
    , 6 // overloaded
    );
  compiler.RegisterParameter(result, 'AValues', H_DYNARRAY_Extended, _parCONST);
end;


function Address_InRange_1: Pointer;
type
  T = function (const AValue, AMin, AMax: Integer): Boolean;
var
  P: T;
begin
  P := InRange;
  Move(P, result, SizeOf(Pointer));
end;


// function InRange(const AValue, AMin, AMax: Integer): Boolean; overload; inline;
function RegisterFunction_InRange_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InRange'
    , _typeBOOLEAN // result type
    , Address_InRange_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeINTEGER, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeINTEGER, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeINTEGER, _parCONST);
end;


function Address_InRange_2: Pointer;
type
  T = function (const AValue, AMin, AMax: Int64): Boolean;
var
  P: T;
begin
  P := InRange;
  Move(P, result, SizeOf(Pointer));
end;


// function InRange(const AValue, AMin, AMax: Int64): Boolean; overload; inline;
function RegisterFunction_InRange_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InRange'
    , _typeBOOLEAN // result type
    , Address_InRange_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeINT64, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeINT64, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeINT64, _parCONST);
end;


function Address_InRange_3: Pointer;
type
  T = function (const AValue, AMin, AMax: UInt64): Boolean;
var
  P: T;
begin
  P := InRange;
  Move(P, result, SizeOf(Pointer));
end;


// function InRange(const AValue, AMin, AMax: UInt64): Boolean; overload; inline;
function RegisterFunction_InRange_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InRange'
    , _typeBOOLEAN // result type
    , Address_InRange_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeUINT64, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeUINT64, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeUINT64, _parCONST);
end;


function Address_InRange_4: Pointer;
type
  T = function (const AValue, AMin, AMax: Single): Boolean;
var
  P: T;
begin
  P := InRange;
  Move(P, result, SizeOf(Pointer));
end;


// function InRange(const AValue, AMin, AMax: Single): Boolean; overload; inline;
function RegisterFunction_InRange_4(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InRange'
    , _typeBOOLEAN // result type
    , Address_InRange_4 // address
    , _ccREGISTER
    , 4 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeSINGLE, _parCONST);
end;


function Address_InRange_5: Pointer;
type
  T = function (const AValue, AMin, AMax: Double): Boolean;
var
  P: T;
begin
  P := InRange;
  Move(P, result, SizeOf(Pointer));
end;


// function InRange(const AValue, AMin, AMax: Double): Boolean; overload; inline;
function RegisterFunction_InRange_5(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InRange'
    , _typeBOOLEAN // result type
    , Address_InRange_5 // address
    , _ccREGISTER
    , 5 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeDOUBLE, _parCONST);
end;


function Address_InRange_6: Pointer;
type
  T = function (const AValue, AMin, AMax: Extended): Boolean;
var
  P: T;
begin
  P := InRange;
  Move(P, result, SizeOf(Pointer));
end;


// function InRange(const AValue, AMin, AMax: Extended): Boolean; overload; inline;
function RegisterFunction_InRange_6(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InRange'
    , _typeBOOLEAN // result type
    , Address_InRange_6 // address
    , _ccREGISTER
    , 6 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeEXTENDED, _parCONST);
end;


function Address_EnsureRange_1: Pointer;
type
  T = function (const AValue, AMin, AMax: Integer): Integer;
var
  P: T;
begin
  P := EnsureRange;
  Move(P, result, SizeOf(Pointer));
end;


// function EnsureRange(const AValue, AMin, AMax: Integer): Integer; overload;
function RegisterFunction_EnsureRange_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('EnsureRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'EnsureRange'
    , _typeINTEGER // result type
    , Address_EnsureRange_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeINTEGER, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeINTEGER, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeINTEGER, _parCONST);
end;


function Address_EnsureRange_2: Pointer;
type
  T = function (const AValue, AMin, AMax: Int64): Int64;
var
  P: T;
begin
  P := EnsureRange;
  Move(P, result, SizeOf(Pointer));
end;


// function EnsureRange(const AValue, AMin, AMax: Int64): Int64; overload;
function RegisterFunction_EnsureRange_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('EnsureRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'EnsureRange'
    , _typeINT64 // result type
    , Address_EnsureRange_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeINT64, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeINT64, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeINT64, _parCONST);
end;


function Address_EnsureRange_3: Pointer;
type
  T = function (const AValue, AMin, AMax: UInt64): UInt64;
var
  P: T;
begin
  P := EnsureRange;
  Move(P, result, SizeOf(Pointer));
end;


// function EnsureRange(const AValue, AMin, AMax: UInt64): UInt64; overload;
function RegisterFunction_EnsureRange_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('EnsureRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'EnsureRange'
    , _typeUINT64 // result type
    , Address_EnsureRange_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeUINT64, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeUINT64, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeUINT64, _parCONST);
end;


function Address_EnsureRange_4: Pointer;
type
  T = function (const AValue, AMin, AMax: Single): Single;
var
  P: T;
begin
  P := EnsureRange;
  Move(P, result, SizeOf(Pointer));
end;


// function EnsureRange(const AValue, AMin, AMax: Single): Single; overload;
function RegisterFunction_EnsureRange_4(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('EnsureRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'EnsureRange'
    , _typeSINGLE // result type
    , Address_EnsureRange_4 // address
    , _ccREGISTER
    , 4 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeSINGLE, _parCONST);
end;


function Address_EnsureRange_5: Pointer;
type
  T = function (const AValue, AMin, AMax: Double): Double;
var
  P: T;
begin
  P := EnsureRange;
  Move(P, result, SizeOf(Pointer));
end;


// function EnsureRange(const AValue, AMin, AMax: Double): Double; overload;
function RegisterFunction_EnsureRange_5(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('EnsureRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'EnsureRange'
    , _typeDOUBLE // result type
    , Address_EnsureRange_5 // address
    , _ccREGISTER
    , 5 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeDOUBLE, _parCONST);
end;


function Address_EnsureRange_6: Pointer;
type
  T = function (const AValue, AMin, AMax: Extended): Extended;
var
  P: T;
begin
  P := EnsureRange;
  Move(P, result, SizeOf(Pointer));
end;


// function EnsureRange(const AValue, AMin, AMax: Extended): Extended; overload;
function RegisterFunction_EnsureRange_6(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('EnsureRange') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'EnsureRange'
    , _typeEXTENDED // result type
    , Address_EnsureRange_6 // address
    , _ccREGISTER
    , 6 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'AMin', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'AMax', _typeEXTENDED, _parCONST);
end;


function Address_DivMod_1: Pointer;
type
  T = procedure (Dividend: Cardinal; Divisor: Word;
  var Result, Remainder: Word);
var
  P: T;
begin
  P := DivMod;
  Move(P, result, SizeOf(Pointer));
end;


// procedure DivMod(Dividend: Cardinal; Divisor: Word;  var Result, Remainder: Word); overload;
function RegisterProcedure_DivMod_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DivMod') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DivMod'
    , _typeVOID // result type
    , Address_DivMod_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'Dividend', _typeCARDINAL, _parVAL);
  compiler.RegisterParameter(result, 'Divisor', _typeWORD, _parVAL);
  compiler.RegisterParameter(result, 'Result', _typeWORD, _parVAR);
  compiler.RegisterParameter(result, 'Remainder', _typeWORD, _parVAR);
end;


function Address_DivMod_2: Pointer;
type
  T = procedure (Dividend: UInt64; Divisor: UInt64;
  var Result, Remainder: UInt64);
var
  P: T;
begin
  P := DivMod;
  Move(P, result, SizeOf(Pointer));
end;


// procedure DivMod(Dividend: UInt64; Divisor: UInt64;  var Result, Remainder: UInt64); overload;
function RegisterProcedure_DivMod_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DivMod') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DivMod'
    , _typeVOID // result type
    , Address_DivMod_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'Dividend', _typeUINT64, _parVAL);
  compiler.RegisterParameter(result, 'Divisor', _typeUINT64, _parVAL);
  compiler.RegisterParameter(result, 'Result', _typeUINT64, _parVAR);
  compiler.RegisterParameter(result, 'Remainder', _typeUINT64, _parVAR);
end;


// function RoundTo(const AValue: Extended;                 const ADigit: TRoundToEXRangeExtended): Extended;
function RegisterFunction_RoundTo(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RoundTo') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RoundTo'
    , _typeEXTENDED // result type
    , @ RoundTo // address
    );
  compiler.RegisterParameter(result, 'AValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'ADigit', 'TRoundToEXRangeExtended', _parCONST);
end;


function Address_SimpleRoundTo_1: Pointer;
type
  T = function (const AValue: Single; const ADigit: TRoundToRange = -2): Single;
var
  P: T;
begin
  P := SimpleRoundTo;
  Move(P, result, SizeOf(Pointer));
end;


// function SimpleRoundTo(const AValue: Single; const ADigit: TRoundToRange = -2): Single; overload;
function RegisterFunction_SimpleRoundTo_1(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SimpleRoundTo') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SimpleRoundTo'
    , _typeSINGLE // result type
    , Address_SimpleRoundTo_1 // address
    , _ccREGISTER
    , 1 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeSINGLE, _parCONST);
  compiler.RegisterParameter(result, 'ADigit', 'TRoundToRange', _parCONST, true, '-2');
end;


function Address_SimpleRoundTo_2: Pointer;
type
  T = function (const AValue: Double; const ADigit: TRoundToRange = -2): Double;
var
  P: T;
begin
  P := SimpleRoundTo;
  Move(P, result, SizeOf(Pointer));
end;


// function SimpleRoundTo(const AValue: Double; const ADigit: TRoundToRange = -2): Double; overload;
function RegisterFunction_SimpleRoundTo_2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SimpleRoundTo') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SimpleRoundTo'
    , _typeDOUBLE // result type
    , Address_SimpleRoundTo_2 // address
    , _ccREGISTER
    , 2 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeDOUBLE, _parCONST);
  compiler.RegisterParameter(result, 'ADigit', 'TRoundToRange', _parCONST, true, '-2');
end;


function Address_SimpleRoundTo_3: Pointer;
type
  T = function (const AValue: Extended; const ADigit: TRoundToRange = -2): Extended;
var
  P: T;
begin
  P := SimpleRoundTo;
  Move(P, result, SizeOf(Pointer));
end;


// function SimpleRoundTo(const AValue: Extended; const ADigit: TRoundToRange = -2): Extended; overload;
function RegisterFunction_SimpleRoundTo_3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SimpleRoundTo') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SimpleRoundTo'
    , _typeEXTENDED // result type
    , Address_SimpleRoundTo_3 // address
    , _ccREGISTER
    , 3 // overloaded
    );
  compiler.RegisterParameter(result, 'AValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'ADigit', 'TRoundToRange', _parCONST, true, '-2');
end;


// function DoubleDecliningBalance(const Cost, Salvage: Extended;  Life, Period: Integer): Extended;
function RegisterFunction_DoubleDecliningBalance(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('DoubleDecliningBalance') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'DoubleDecliningBalance'
    , _typeEXTENDED // result type
    , @ DoubleDecliningBalance // address
    );
  compiler.RegisterParameter(result, 'Cost', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Salvage', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Life', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Period', _typeINTEGER, _parVAL);
end;


// function FutureValue(const Rate: Extended; NPeriods: Integer; const Payment,  PresentValue: Extended; PaymentTime: TPaymentTime): Extended;
function RegisterFunction_FutureValue(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('FutureValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'FutureValue'
    , _typeEXTENDED // result type
    , @ FutureValue // address
    );
  compiler.RegisterParameter(result, 'Rate', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'NPeriods', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Payment', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'PresentValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'PaymentTime', 'TPaymentTime', _parVAL);
end;


// function InterestPayment(const Rate: Extended; Period, NPeriods: Integer;  const PresentValue, FutureValue: Extended; PaymentTime: TPaymentTime): Extended;
function RegisterFunction_InterestPayment(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InterestPayment') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InterestPayment'
    , _typeEXTENDED // result type
    , @ InterestPayment // address
    );
  compiler.RegisterParameter(result, 'Rate', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Period', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'NPeriods', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'PresentValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'FutureValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'PaymentTime', 'TPaymentTime', _parVAL);
end;


// function InterestRate(NPeriods: Integer; const Payment, PresentValue,  FutureValue: Extended; PaymentTime: TPaymentTime): Extended;
function RegisterFunction_InterestRate(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InterestRate') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InterestRate'
    , _typeEXTENDED // result type
    , @ InterestRate // address
    );
  compiler.RegisterParameter(result, 'NPeriods', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Payment', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'PresentValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'FutureValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'PaymentTime', 'TPaymentTime', _parVAL);
end;


// function InternalRateOfReturn(const Guess: Extended;  const CashFlows: array of Double): Extended;
function RegisterFunction_InternalRateOfReturn(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('InternalRateOfReturn') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'InternalRateOfReturn'
    , _typeEXTENDED // result type
    , @ InternalRateOfReturn // address
    );
  compiler.RegisterParameter(result, 'Guess', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'CashFlows', H_DYNARRAY_Double, _parCONST);
end;


// function NumberOfPeriods(const Rate: Extended; Payment: Extended;  const PresentValue, FutureValue: Extended; PaymentTime: TPaymentTime): Extended;
function RegisterFunction_NumberOfPeriods(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('NumberOfPeriods') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'NumberOfPeriods'
    , _typeEXTENDED // result type
    , @ NumberOfPeriods // address
    );
  compiler.RegisterParameter(result, 'Rate', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Payment', _typeEXTENDED, _parVAL);
  compiler.RegisterParameter(result, 'PresentValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'FutureValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'PaymentTime', 'TPaymentTime', _parVAL);
end;


// function NetPresentValue(const Rate: Extended; const CashFlows: array of Double;  PaymentTime: TPaymentTime): Extended;
function RegisterFunction_NetPresentValue(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('NetPresentValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'NetPresentValue'
    , _typeEXTENDED // result type
    , @ NetPresentValue // address
    );
  compiler.RegisterParameter(result, 'Rate', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'CashFlows', H_DYNARRAY_Double, _parCONST);
  compiler.RegisterParameter(result, 'PaymentTime', 'TPaymentTime', _parVAL);
end;


// function Payment(Rate: Extended; NPeriods: Integer; const PresentValue,  FutureValue: Extended; PaymentTime: TPaymentTime): Extended;
function RegisterFunction_Payment(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('Payment') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'Payment'
    , _typeEXTENDED // result type
    , @ Payment // address
    );
  compiler.RegisterParameter(result, 'Rate', _typeEXTENDED, _parVAL);
  compiler.RegisterParameter(result, 'NPeriods', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'PresentValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'FutureValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'PaymentTime', 'TPaymentTime', _parVAL);
end;


// function PeriodPayment(const Rate: Extended; Period, NPeriods: Integer;  const PresentValue, FutureValue: Extended; PaymentTime: TPaymentTime): Extended;
function RegisterFunction_PeriodPayment(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('PeriodPayment') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'PeriodPayment'
    , _typeEXTENDED // result type
    , @ PeriodPayment // address
    );
  compiler.RegisterParameter(result, 'Rate', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Period', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'NPeriods', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'PresentValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'FutureValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'PaymentTime', 'TPaymentTime', _parVAL);
end;


// function PresentValue(const Rate: Extended; NPeriods: Integer;  const Payment, FutureValue: Extended; PaymentTime: TPaymentTime): Extended;
function RegisterFunction_PresentValue(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('PresentValue') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'PresentValue'
    , _typeEXTENDED // result type
    , @ PresentValue // address
    );
  compiler.RegisterParameter(result, 'Rate', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'NPeriods', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Payment', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'FutureValue', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'PaymentTime', 'TPaymentTime', _parVAL);
end;


// function SLNDepreciation(const Cost, Salvage: Extended; Life: Integer): Extended;
function RegisterFunction_SLNDepreciation(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SLNDepreciation') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SLNDepreciation'
    , _typeEXTENDED // result type
    , @ SLNDepreciation // address
    );
  compiler.RegisterParameter(result, 'Cost', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Salvage', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Life', _typeINTEGER, _parVAL);
end;


// function SYDDepreciation(const Cost, Salvage: Extended; Life, Period: Integer): Extended;
function RegisterFunction_SYDDepreciation(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SYDDepreciation') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SYDDepreciation'
    , _typeEXTENDED // result type
    , @ SYDDepreciation // address
    );
  compiler.RegisterParameter(result, 'Cost', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Salvage', _typeEXTENDED, _parCONST);
  compiler.RegisterParameter(result, 'Life', _typeINTEGER, _parVAL);
  compiler.RegisterParameter(result, 'Period', _typeINTEGER, _parVAL);
end;


// function GetFPURoundMode: TFPURoundingMode; platform;
function RegisterFunction_GetFPURoundMode(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GetFPURoundMode') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GetFPURoundMode'
    , 'TFPURoundingMode' // result type
    , @ GetFPURoundMode // address
    );
end;


// function GetSSERoundMode: TSSERoundingMode; platform;
function RegisterFunction_GetSSERoundMode(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GetSSERoundMode') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GetSSERoundMode'
    , 'TSSERoundingMode' // result type
    , @ GetSSERoundMode // address
    );
end;


// function GetRoundMode: TRoundingMode;
function RegisterFunction_GetRoundMode(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GetRoundMode') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GetRoundMode'
    , 'TRoundingMode' // result type
    , @ GetRoundMode // address
    );
end;


// function SetFPURoundMode(const RoundMode: TFPURoundingMode): TFPURoundingMode; platform;
function RegisterFunction_SetFPURoundMode(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SetFPURoundMode') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SetFPURoundMode'
    , 'TFPURoundingMode' // result type
    , @ SetFPURoundMode // address
    );
  compiler.RegisterParameter(result, 'RoundMode', 'TFPURoundingMode', _parCONST);
end;


// function SetSSERoundMode(const RoundMode: TSSERoundingMode): TSSERoundingMode; platform;
function RegisterFunction_SetSSERoundMode(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SetSSERoundMode') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SetSSERoundMode'
    , 'TSSERoundingMode' // result type
    , @ SetSSERoundMode // address
    );
  compiler.RegisterParameter(result, 'RoundMode', 'TSSERoundingMode', _parCONST);
end;


// function SetRoundMode(const RoundMode: TRoundingMode): TRoundingMode;
function RegisterFunction_SetRoundMode(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SetRoundMode') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SetRoundMode'
    , 'TRoundingMode' // result type
    , @ SetRoundMode // address
    );
  compiler.RegisterParameter(result, 'RoundMode', 'TRoundingMode', _parCONST);
end;


// function GetPrecisionMode: TFPUPrecisionMode; platform;
function RegisterFunction_GetPrecisionMode(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GetPrecisionMode') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GetPrecisionMode'
    , 'TFPUPrecisionMode' // result type
    , @ GetPrecisionMode // address
    );
end;


// function SetPrecisionMode(const Precision: TFPUPrecisionMode): TFPUPrecisionMode; platform;
function RegisterFunction_SetPrecisionMode(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SetPrecisionMode') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SetPrecisionMode'
    , 'TFPUPrecisionMode' // result type
    , @ SetPrecisionMode // address
    );
  compiler.RegisterParameter(result, 'Precision', 'TFPUPrecisionMode', _parCONST);
end;


// function GetFPUExceptionMask: TFPUExceptionMask; platform;
function RegisterFunction_GetFPUExceptionMask(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GetFPUExceptionMask') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GetFPUExceptionMask'
    , 'TFPUExceptionMask' // result type
    , @ GetFPUExceptionMask // address
    );
end;


// function GetSSEExceptionMask: TSSEExceptionMask; platform;
function RegisterFunction_GetSSEExceptionMask(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GetSSEExceptionMask') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GetSSEExceptionMask'
    , 'TSSEExceptionMask' // result type
    , @ GetSSEExceptionMask // address
    );
end;


// function GetExceptionMask: TArithmeticExceptionMask;
function RegisterFunction_GetExceptionMask(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GetExceptionMask') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GetExceptionMask'
    , 'TArithmeticExceptionMask' // result type
    , @ GetExceptionMask // address
    );
end;


// function SetFPUExceptionMask(const Mask: TFPUExceptionMask): TFPUExceptionMask; platform;
function RegisterFunction_SetFPUExceptionMask(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SetFPUExceptionMask') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SetFPUExceptionMask'
    , 'TFPUExceptionMask' // result type
    , @ SetFPUExceptionMask // address
    );
  compiler.RegisterParameter(result, 'Mask', 'TFPUExceptionMask', _parCONST);
end;


// function SetSSEExceptionMask(const Mask: TSSEExceptionMask): TSSEExceptionMask; platform;
function RegisterFunction_SetSSEExceptionMask(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SetSSEExceptionMask') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SetSSEExceptionMask'
    , 'TSSEExceptionMask' // result type
    , @ SetSSEExceptionMask // address
    );
  compiler.RegisterParameter(result, 'Mask', 'TSSEExceptionMask', _parCONST);
end;


// function SetExceptionMask(const Mask: TArithmeticExceptionMask): TArithmeticExceptionMask;
function RegisterFunction_SetExceptionMask(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SetExceptionMask') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SetExceptionMask'
    , 'TArithmeticExceptionMask' // result type
    , @ SetExceptionMask // address
    );
  compiler.RegisterParameter(result, 'Mask', 'TArithmeticExceptionMask', _parCONST);
end;


// procedure ClearFPUExceptions(RaisePending: Boolean = True); platform;
function RegisterProcedure_ClearFPUExceptions(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ClearFPUExceptions') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ClearFPUExceptions'
    , _typeVOID // result type
    , @ ClearFPUExceptions // address
    );
  compiler.RegisterParameter(result, 'RaisePending', _typeBOOLEAN, _parVAL, true, 'True');
end;


// procedure ClearSSEExceptions(RaisePending: Boolean = True); platform;
function RegisterProcedure_ClearSSEExceptions(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ClearSSEExceptions') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ClearSSEExceptions'
    , _typeVOID // result type
    , @ ClearSSEExceptions // address
    );
  compiler.RegisterParameter(result, 'RaisePending', _typeBOOLEAN, _parVAL, true, 'True');
end;


// procedure ClearExceptions(RaisePending: Boolean = True; ExceptionFlags: TArithmeticExceptions = DefaultExceptionFlags);
function RegisterProcedure_ClearExceptions(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('ClearExceptions') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'ClearExceptions'
    , _typeVOID // result type
    , @ ClearExceptions // address
    );
  compiler.RegisterParameter(result, 'RaisePending', _typeBOOLEAN, _parVAL, true, 'True');
  compiler.RegisterParameter(result, 'ExceptionFlags', 'TArithmeticExceptions', _parVAL, true, 'DefaultExceptionFlags');
end;


// function GetExceptions: TArithmeticExceptions;
function RegisterFunction_GetExceptions(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('GetExceptions') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'GetExceptions'
    , 'TArithmeticExceptions' // result type
    , @ GetExceptions // address
    );
end;


// function SetExceptions(const Exceptions: TArithmeticExceptions): TArithmeticExceptions;
function RegisterFunction_SetExceptions(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('SetExceptions') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'SetExceptions'
    , 'TArithmeticExceptions' // result type
    , @ SetExceptions // address
    );
  compiler.RegisterParameter(result, 'Exceptions', 'TArithmeticExceptions', _parCONST);
end;


// procedure RaisEexceptions(const ExceptionFlags: TArithmeticExceptions = DefaultExceptionFlags);
function RegisterProcedure_RaisEexceptions(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('RaisEexceptions') then begin result := 0; Exit; end;
  result := compiler.RegisterRoutine(H, 'RaisEexceptions'
    , _typeVOID // result type
    , @ RaisEexceptions // address
    );
  compiler.RegisterParameter(result, 'ExceptionFlags', 'TArithmeticExceptions', _parCONST, true, 'DefaultExceptionFlags');
end;


function RegisterConstant__seSSE(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('seSSE') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'seSSE', $0001);
end;


function RegisterConstant__seSSE2(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('seSSE2') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'seSSE2', $0002);
end;


function RegisterConstant__seSSE3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('seSSE3') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'seSSE3', $0004);
end;


function RegisterConstant__seSSSE3(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('seSSSE3') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'seSSSE3', $0008);
end;


function RegisterConstant__seSSE41(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('seSSE41') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'seSSE41', $0010);
end;


function RegisterConstant__seSSE42(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('seSSE42') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'seSSE42', $0020);
end;


function RegisterConstant__sePOPCNT(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('sePOPCNT') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'sePOPCNT', $0040);
end;


function RegisterConstant__seAESNI(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('seAESNI') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'seAESNI', $0080);
end;


function RegisterConstant__sePCLMULQDQ(H: Integer; compiler: TPaxCompiler): Integer;
begin
  if not Compiler.InScript('sePCLMULQDQ') then begin result := 0; Exit; end;
  result := compiler.RegisterConstant(H, 'sePCLMULQDQ', $0100);
end;


procedure Part1(result: Integer; compiler: TPaxCompiler);
begin
  RegisterConstant__MinSingle(result, compiler);
  RegisterConstant__MaxSingle(result, compiler);
  RegisterConstant__MinDouble(result, compiler);
  RegisterConstant__MaxDouble(result, compiler);
  RegisterConstant__MinExtended(result, compiler);
  RegisterConstant__MaxExtended(result, compiler);
  RegisterConstant__MinComp(result, compiler);
  RegisterConstant__MaxComp(result, compiler);
  RegisterFunction_ArcCos_1(result, compiler);
  RegisterFunction_ArcCos_2(result, compiler);
  RegisterFunction_ArcCos_3(result, compiler);
  RegisterFunction_ArcSin_1(result, compiler);
  RegisterFunction_ArcSin_2(result, compiler);
  RegisterFunction_ArcSin_3(result, compiler);
  RegisterFunction_ArcTan2_1(result, compiler);
  RegisterFunction_ArcTan2_2(result, compiler);
  RegisterFunction_ArcTan2_3(result, compiler);
  RegisterProcedure_SinCos_1(result, compiler);
  RegisterProcedure_SinCos_2(result, compiler);
  RegisterProcedure_SinCos_3(result, compiler);
  RegisterFunction_Tan_1(result, compiler);
  RegisterFunction_Tan_2(result, compiler);
  RegisterFunction_Tan_3(result, compiler);
  RegisterFunction_Cotan_1(result, compiler);
  RegisterFunction_Cotan_2(result, compiler);
  RegisterFunction_Cotan_3(result, compiler);
  RegisterFunction_Secant_1(result, compiler);
  RegisterFunction_Secant_2(result, compiler);
  RegisterFunction_Secant_3(result, compiler);
  RegisterFunction_Cosecant_1(result, compiler);
  RegisterFunction_Cosecant_2(result, compiler);
  RegisterFunction_Cosecant_3(result, compiler);
  RegisterFunction_Hypot_1(result, compiler);
  RegisterFunction_Hypot_2(result, compiler);
  RegisterFunction_Hypot_3(result, compiler);
  RegisterFunction_RadToDeg_1(result, compiler);
  RegisterFunction_RadToDeg_2(result, compiler);
  RegisterFunction_RadToDeg_3(result, compiler);
  RegisterFunction_RadToGrad_1(result, compiler);
  RegisterFunction_RadToGrad_2(result, compiler);
  RegisterFunction_RadToGrad_3(result, compiler);
  RegisterFunction_RadToCycle_1(result, compiler);
  RegisterFunction_RadToCycle_2(result, compiler);
  RegisterFunction_RadToCycle_3(result, compiler);
  RegisterFunction_DegToRad_1(result, compiler);
  RegisterFunction_DegToRad_2(result, compiler);
  RegisterFunction_DegToRad_3(result, compiler);
  RegisterFunction_DegToGrad_1(result, compiler);
  RegisterFunction_DegToGrad_2(result, compiler);
  RegisterFunction_DegToGrad_3(result, compiler);
  RegisterFunction_DegToCycle_1(result, compiler);
  RegisterFunction_DegToCycle_2(result, compiler);
  RegisterFunction_DegToCycle_3(result, compiler);
  RegisterFunction_DegNormalize_1(result, compiler);
  RegisterFunction_DegNormalize_2(result, compiler);
  RegisterFunction_DegNormalize_3(result, compiler);
  RegisterFunction_GradToRad_1(result, compiler);
  RegisterFunction_GradToRad_2(result, compiler);
  RegisterFunction_GradToRad_3(result, compiler);
  RegisterFunction_GradToDeg_1(result, compiler);
  RegisterFunction_GradToDeg_2(result, compiler);
  RegisterFunction_GradToDeg_3(result, compiler);
  RegisterFunction_GradToCycle_1(result, compiler);
  RegisterFunction_GradToCycle_2(result, compiler);
  RegisterFunction_GradToCycle_3(result, compiler);
  RegisterFunction_CycleToRad_1(result, compiler);
  RegisterFunction_CycleToRad_2(result, compiler);
  RegisterFunction_CycleToRad_3(result, compiler);
  RegisterFunction_CycleToDeg_1(result, compiler);
  RegisterFunction_CycleToDeg_2(result, compiler);
  RegisterFunction_CycleToDeg_3(result, compiler);
  RegisterFunction_CycleToGrad_1(result, compiler);
  RegisterFunction_CycleToGrad_2(result, compiler);
  RegisterFunction_CycleToGrad_3(result, compiler);
  RegisterFunction_Cot_1(result, compiler);
  RegisterFunction_Cot_2(result, compiler);
  RegisterFunction_Cot_3(result, compiler);
  RegisterFunction_Sec_1(result, compiler);
  RegisterFunction_Sec_2(result, compiler);
  RegisterFunction_Sec_3(result, compiler);
  RegisterFunction_Csc_1(result, compiler);
  RegisterFunction_Csc_2(result, compiler);
  RegisterFunction_Csc_3(result, compiler);
  RegisterFunction_Cosh_1(result, compiler);
  RegisterFunction_Cosh_2(result, compiler);
  RegisterFunction_Cosh_3(result, compiler);
  RegisterFunction_Sinh_1(result, compiler);
  RegisterFunction_Sinh_2(result, compiler);
  RegisterFunction_Sinh_3(result, compiler);
  RegisterFunction_Tanh_1(result, compiler);
  RegisterFunction_Tanh_2(result, compiler);
  RegisterFunction_Tanh_3(result, compiler);
  RegisterFunction_CotH_1(result, compiler);
  RegisterFunction_CotH_2(result, compiler);
  RegisterFunction_CotH_3(result, compiler);
  RegisterFunction_SecH_1(result, compiler);
  RegisterFunction_SecH_2(result, compiler);
  RegisterFunction_SecH_3(result, compiler);
  RegisterFunction_CscH_1(result, compiler);
  RegisterFunction_CscH_2(result, compiler);
  RegisterFunction_CscH_3(result, compiler);
  RegisterFunction_ArcCot_1(result, compiler);
  RegisterFunction_ArcCot_2(result, compiler);
  RegisterFunction_ArcCot_3(result, compiler);
  RegisterFunction_ArcSec_1(result, compiler);
  RegisterFunction_ArcSec_2(result, compiler);
  RegisterFunction_ArcSec_3(result, compiler);
  RegisterFunction_ArcCsc_1(result, compiler);
  RegisterFunction_ArcCsc_2(result, compiler);
  RegisterFunction_ArcCsc_3(result, compiler);
  RegisterFunction_ArcCosh_1(result, compiler);
  RegisterFunction_ArcCosh_2(result, compiler);
  RegisterFunction_ArcCosh_3(result, compiler);
  RegisterFunction_ArcSinh_1(result, compiler);
  RegisterFunction_ArcSinh_2(result, compiler);
  RegisterFunction_ArcSinh_3(result, compiler);
  RegisterFunction_ArcTanh_1(result, compiler);
  RegisterFunction_ArcTanh_2(result, compiler);
  RegisterFunction_ArcTanh_3(result, compiler);
  RegisterFunction_ArcCotH_1(result, compiler);
  RegisterFunction_ArcCotH_2(result, compiler);
  RegisterFunction_ArcCotH_3(result, compiler);
  RegisterFunction_ArcSecH_1(result, compiler);
  RegisterFunction_ArcSecH_2(result, compiler);
  RegisterFunction_ArcSecH_3(result, compiler);
  RegisterFunction_ArcCscH_1(result, compiler);
  RegisterFunction_ArcCscH_2(result, compiler);
  RegisterFunction_ArcCscH_3(result, compiler);
  RegisterFunction_LnXP1_1(result, compiler);
  RegisterFunction_LnXP1_2(result, compiler);
  RegisterFunction_LnXP1_3(result, compiler);
  RegisterFunction_Log10_1(result, compiler);
  RegisterFunction_Log10_2(result, compiler);
  RegisterFunction_Log10_3(result, compiler);
  RegisterFunction_Log2_1(result, compiler);
  RegisterFunction_Log2_2(result, compiler);
  RegisterFunction_Log2_3(result, compiler);
  RegisterFunction_LogN_1(result, compiler);
  RegisterFunction_LogN_2(result, compiler);
  RegisterFunction_LogN_3(result, compiler);
  RegisterFunction_IntPower_1(result, compiler);
  RegisterFunction_IntPower_2(result, compiler);
  RegisterFunction_IntPower_3(result, compiler);
  RegisterFunction_Power_1(result, compiler);
  RegisterFunction_Power_2(result, compiler);
  RegisterFunction_Power_3(result, compiler);
  RegisterProcedure_Frexp_1(result, compiler);
  RegisterProcedure_Frexp_2(result, compiler);
  RegisterProcedure_Frexp_3(result, compiler);
  RegisterFunction_Ldexp_1(result, compiler);
  RegisterFunction_Ldexp_2(result, compiler);
  RegisterFunction_Ldexp_3(result, compiler);
  RegisterFunction_Ceil_1(result, compiler);
  RegisterFunction_Ceil_2(result, compiler);
  RegisterFunction_Ceil_3(result, compiler);
  RegisterFunction_Floor_1(result, compiler);
  RegisterFunction_Floor_2(result, compiler);
  RegisterFunction_Floor_3(result, compiler);
  RegisterFunction_Poly_1(result, compiler);
  RegisterFunction_Poly_2(result, compiler);
  RegisterFunction_Poly_3(result, compiler);
  RegisterFunction_Mean_1(result, compiler);
  RegisterFunction_Mean_2(result, compiler);
  RegisterFunction_Mean_3(result, compiler);
  RegisterFunction_Sum_1(result, compiler);
  RegisterFunction_Sum_2(result, compiler);
  RegisterFunction_Sum_3(result, compiler);
  RegisterFunction_SumInt(result, compiler);
  RegisterFunction_SumOfSquares_1(result, compiler);
  RegisterFunction_SumOfSquares_2(result, compiler);
  RegisterFunction_SumOfSquares_3(result, compiler);
  RegisterProcedure_SumsAndSquares_1(result, compiler);
  RegisterProcedure_SumsAndSquares_2(result, compiler);
  RegisterProcedure_SumsAndSquares_3(result, compiler);
  RegisterFunction_MinValue_1(result, compiler);
  RegisterFunction_MinValue_2(result, compiler);
  RegisterFunction_MinValue_3(result, compiler);
  RegisterFunction_MinIntValue(result, compiler);
  RegisterFunction_Min_1(result, compiler);
  RegisterFunction_Min_2(result, compiler);
  RegisterFunction_Min_3(result, compiler);
  RegisterFunction_Min_4(result, compiler);
  RegisterFunction_Min_5(result, compiler);
  RegisterFunction_Min_6(result, compiler);
  RegisterFunction_MaxValue_1(result, compiler);
  RegisterFunction_MaxValue_2(result, compiler);
  RegisterFunction_MaxValue_3(result, compiler);
  RegisterFunction_MaxIntValue(result, compiler);
  RegisterFunction_Max_1(result, compiler);
  RegisterFunction_Max_2(result, compiler);
  RegisterFunction_Max_3(result, compiler);
  RegisterFunction_Max_4(result, compiler);
  RegisterFunction_Max_5(result, compiler);
  RegisterFunction_Max_6(result, compiler);
  RegisterFunction_StdDev_1(result, compiler);
  RegisterFunction_StdDev_2(result, compiler);
  RegisterFunction_StdDev_3(result, compiler);
  RegisterProcedure_MeanAndStdDev_1(result, compiler);
  RegisterProcedure_MeanAndStdDev_2(result, compiler);
  RegisterProcedure_MeanAndStdDev_3(result, compiler);
  RegisterFunction_PopnStdDev_1(result, compiler);
  RegisterFunction_PopnStdDev_2(result, compiler);
  RegisterFunction_PopnStdDev_3(result, compiler);
  RegisterFunction_Variance_1(result, compiler);
  RegisterFunction_Variance_2(result, compiler);
  RegisterFunction_Variance_3(result, compiler);
  RegisterFunction_PopnVariance_1(result, compiler);
  RegisterFunction_PopnVariance_2(result, compiler);
  RegisterFunction_PopnVariance_3(result, compiler);
  RegisterFunction_TotalVariance_1(result, compiler);
  RegisterFunction_TotalVariance_2(result, compiler);
  RegisterFunction_TotalVariance_3(result, compiler);
  RegisterFunction_Norm_1(result, compiler);
  RegisterFunction_Norm_2(result, compiler);
  RegisterFunction_Norm_3(result, compiler);
  RegisterProcedure_MomentSkewKurtosis(result, compiler);
  RegisterFunction_RandG_1(result, compiler);
  RegisterFunction_RandG_2(result, compiler);
  RegisterFunction_RandG_3(result, compiler);
  RegisterFunction_IsNan_1(result, compiler);
  RegisterFunction_IsNan_2(result, compiler);
  RegisterFunction_IsNan_3(result, compiler);
  RegisterFunction_IsInfinite_1(result, compiler);
  RegisterFunction_IsInfinite_2(result, compiler);
  RegisterFunction_IsInfinite_3(result, compiler);
  RegisterConstant__ZeroValue(result, compiler);
  RegisterFunction_Sign_1(result, compiler);
  RegisterFunction_Sign_2(result, compiler);
  RegisterFunction_Sign_3(result, compiler);
  RegisterFunction_Sign_4(result, compiler);
  RegisterFunction_Sign_5(result, compiler);
  RegisterFunction_CompareValue_1(result, compiler);
  RegisterFunction_CompareValue_2(result, compiler);
  RegisterFunction_CompareValue_3(result, compiler);
  RegisterFunction_CompareValue_4(result, compiler);
  RegisterFunction_CompareValue_5(result, compiler);
  RegisterFunction_CompareValue_6(result, compiler);
  RegisterFunction_SameValue_1(result, compiler);
  RegisterFunction_SameValue_2(result, compiler);
  RegisterFunction_SameValue_3(result, compiler);
  RegisterFunction_IsZero_1(result, compiler);
  RegisterFunction_IsZero_2(result, compiler);
  RegisterFunction_IsZero_3(result, compiler);
  RegisterFunction_IfThen_1(result, compiler);
  RegisterFunction_IfThen_2(result, compiler);
  RegisterFunction_IfThen_3(result, compiler);
  RegisterFunction_IfThen_4(result, compiler);
  RegisterFunction_IfThen_5(result, compiler);
  RegisterFunction_IfThen_6(result, compiler);
  RegisterFunction_RandomRange(result, compiler);
  RegisterFunction_RandomFrom_1(result, compiler);
  RegisterFunction_RandomFrom_2(result, compiler);
  RegisterFunction_RandomFrom_3(result, compiler);
  RegisterFunction_RandomFrom_4(result, compiler);
  RegisterFunction_RandomFrom_5(result, compiler);
  RegisterFunction_RandomFrom_6(result, compiler);
  RegisterFunction_InRange_1(result, compiler);
  RegisterFunction_InRange_2(result, compiler);
  RegisterFunction_InRange_3(result, compiler);
  RegisterFunction_InRange_4(result, compiler);
  RegisterFunction_InRange_5(result, compiler);
  RegisterFunction_InRange_6(result, compiler);
  RegisterFunction_EnsureRange_1(result, compiler);
  RegisterFunction_EnsureRange_2(result, compiler);
  RegisterFunction_EnsureRange_3(result, compiler);
  RegisterFunction_EnsureRange_4(result, compiler);
  RegisterFunction_EnsureRange_5(result, compiler);
  RegisterFunction_EnsureRange_6(result, compiler);
  RegisterProcedure_DivMod_1(result, compiler);
  RegisterProcedure_DivMod_2(result, compiler);
  RegisterFunction_RoundTo(result, compiler);
  RegisterFunction_SimpleRoundTo_1(result, compiler);
  RegisterFunction_SimpleRoundTo_2(result, compiler);
  RegisterFunction_SimpleRoundTo_3(result, compiler);
  RegisterFunction_DoubleDecliningBalance(result, compiler);
  RegisterFunction_FutureValue(result, compiler);
  RegisterFunction_InterestPayment(result, compiler);
  RegisterFunction_InterestRate(result, compiler);
  RegisterFunction_InternalRateOfReturn(result, compiler);
  RegisterFunction_NumberOfPeriods(result, compiler);
  RegisterFunction_NetPresentValue(result, compiler);
  RegisterFunction_Payment(result, compiler);
  RegisterFunction_PeriodPayment(result, compiler);
  RegisterFunction_PresentValue(result, compiler);
  RegisterFunction_SLNDepreciation(result, compiler);
  RegisterFunction_SYDDepreciation(result, compiler);
  RegisterFunction_GetFPURoundMode(result, compiler);
  RegisterFunction_GetSSERoundMode(result, compiler);
  RegisterFunction_GetRoundMode(result, compiler);
  RegisterFunction_SetFPURoundMode(result, compiler);
  RegisterFunction_SetSSERoundMode(result, compiler);
  RegisterFunction_SetRoundMode(result, compiler);
  RegisterFunction_GetPrecisionMode(result, compiler);
  RegisterFunction_SetPrecisionMode(result, compiler);
  RegisterFunction_GetFPUExceptionMask(result, compiler);
  RegisterFunction_GetSSEExceptionMask(result, compiler);
  RegisterFunction_GetExceptionMask(result, compiler);
  RegisterFunction_SetFPUExceptionMask(result, compiler);
  RegisterFunction_SetSSEExceptionMask(result, compiler);
  RegisterFunction_SetExceptionMask(result, compiler);
  RegisterProcedure_ClearFPUExceptions(result, compiler);
  RegisterProcedure_ClearSSEExceptions(result, compiler);
  RegisterProcedure_ClearExceptions(result, compiler);
  RegisterFunction_GetExceptions(result, compiler);
  RegisterFunction_SetExceptions(result, compiler);
  RegisterProcedure_RaisEexceptions(result, compiler);
  RegisterConstant__seSSE(result, compiler);
  RegisterConstant__seSSE2(result, compiler);
  RegisterConstant__seSSE3(result, compiler);
  RegisterConstant__seSSSE3(result, compiler);
  RegisterConstant__seSSE41(result, compiler);
  RegisterConstant__seSSE42(result, compiler);
  RegisterConstant__sePOPCNT(result, compiler);
  RegisterConstant__seAESNI(result, compiler);
  RegisterConstant__sePCLMULQDQ(result, compiler);
end;

function Register_System_Math(compiler: TPaxCompiler): Integer;
begin
  if not compiler.InScript('System.Math') then begin result := 0; Exit; end;
  result := compiler.RegisterNamespace(0, 'System.Math');
  compiler.RegisterUsingNamespace('System.SysUtils');
  compiler.RegisterUsingNamespace('System.Types');
  Part1(result, compiler);
  compiler.UnregisterUsingNamespaces;
end;

end.
